'************************************************************************************
' This script sets the third character of the dSHeuristics attribute to 1
' this puts the Active Directory Forest into "use LIST OBJECT permissions" mode.
'
' To reset the the Active Directory Forest from the "use LIST OBJECT permissions" mode,
' the third character of the dSHeuristics attribute needs to be set to 0.
'*******************************************************************************

Option Explicit
Dim dse, configObjectDN, configObject, heuristics, newHeuristics

'*************************************************************
' read the dSHeuristics attribute into heuristics
' if the attribute is not set, set heuristics to ""
'*************************************************************
Sub GetHeuristics
  On Error Resume Next
  heuristics = configObject.Get("dSHeuristics")
  If Err Then
    If Err.Number = &H8000500D Then
' no error -- the dSHeuristics attribute was just unset
      heuristics = ""
    Else
      WScript.Echo Err.Description
      WScript.Quit(1)
    End If
  End If
End Sub


Set dse = GetObject("LDAP://localhost/RootDSE")
configObjectDN = "LDAP://localhost/CN=Directory Service,CN=Windows NT,CN=Services,"
configObjectDN = configObjectDN & dse.Get("configurationNamingContext")
Set configObject = GetObject(configObjectDN)
GetHeuristics
WScript.Echo "old heuristics: " & heuristics
newHeuristics = Left(heuristics, 2)
newHeuristics = newHeuristics & Left("00", 2-Len(newHeuristics))
newHeuristics = newHeuristics & "1"
WScript.Echo "new heuristics: " & newheuristics
If Len(heuristics) > 3 Then
  newHeuristics = newHeuristics & Right(heuristics, Len(heuristics)-3)
End If
' WScript.Echo "new heuristics: " & newHeuristics
configObject.Put "dSHeuristics", newHeuristics
configObject.SetInfo
