<!--#Include File="Lib/Main.asp" -->
<!--#Include File="Lib/OULooping.asp" -->
<!--#Include File="Lib/CurrentUser.asp" -->
<html>
<head>
<meta HTTP-EQUIV="PICS-Label" CONTENT='(PICS-1.1 "http://www.rsac.org/ ratingsv01.html" l comment "RSACi North America Server" by "inet@microsoft.com " r (n 0 s 0 v 0 l 0))'>
<meta HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">
<title>Building Guid Cache Files...</title>
</head>
<body bgcolor="#FFFFFF">
<table width="100%">
<tr>
<td>
<img id="ix1" SRC="images\icon2.gif" ALT="Windows Update Logo" WIDTH="55" HEIGHT="55">
</td>
<td>
<font id="f1" STYLE="COLOR:#000080;FONT-FAMILY: Verdana, Arial;FONT-SIZE: 30pt;FONT-WEIGHT: Bold"><id ID="x1">Please Wait...</id></font><br>
</td>
</table>
<font id="f2" STYLE="COLOR: #00319C;FONT-FAMILY: Verdana, Arial;FONT-SIZE: 10pt; font-weight:bold;"><id ID="x2">Building GUID Cache Files</id></font>
<BR><BR>
</body>
</html>

<%
Response.Flush
'//************************************************************************
'//                           CreateGUIDCacheFiles.asp
'//
'// this page creates two files (rightsGuid.txt and schemaIDGUID.txt) that contain the
'// schemaIDGUID <-> Common Name (and rightsGuid <-> Common Name) lookup table data to disk.
'// These files are read in by the ViewACE.asp page to help build the Rights listing of an
'// object such as an OU. The reason these files are used is that it takes a long time
'// to generate the schemaIDGUID <-> Common Name and rightsGuid <-> Common Name information.
'// By running this information and persisting it to disk, the listing of the objects's
'// DACLs is greatly speed up for the user of the ViewACE.asp
'// disk-based cache files to build their internal lookup tables rather than going directly
'// to the Schema and Configuration naming contexts. 

'// In the event a new structural class or attribute is added to the schema, or 
'// a new extended right is added to the Extended-Rights
'// container, simply re-run CreateGuidCacheFiles.asp to update the files.
'//
'// for this routine to run correctly it is required that ADsType.dll is regisered on the
'// server where thes ASP pages will reside.
'// To register ADsType.dll run from the command line -  regsvr32.exe ADsType.dll
'//***********************************************************************************



Call CreateRightsGuidCache
Call CreateSchemaIdGuidCache
Call Finished

Sub Finished()
	%>
		<SCRIPT LANGUAGE=javascript>
		<!--
			window.opener.document.location.reload();
			window.close();
		//-->
		</SCRIPT>
	<%
End Sub

'**********************************************************************
'* Subroutine: CreateRightsGuidCache
'**********************************************************************
Sub CreateRightsGuidCache()

On Error Resume Next

   Dim oRoot, oExtendedRightsContainer, oExtendedRightsObject, oFSO, oRightsGuidCache, object
   Dim strConfigurationNamingContext, strRightsGuid
   Dim sFilePath
   
   Response.Write "<strong>Starting: CreateRightsGuidCache"
   Response.Write "</strong>"
   Response.Write "..."
   Response.Flush 

   Set oRoot = GetObject("LDAP://RootDSE")
   strConfigurationNamingContext = oRoot.Get("configurationNamingContext")

   Set oExtendedRightsContainer = GetObject("LDAP://cn=extended-rights," & strConfigurationNamingContext)

   Set oFSO = CreateObject("Scripting.FileSystemObject")
   '//Set oRightsGuidCache = oFSO.CreateTextFile("c:\tmp\rightsGuid.txt", True, False)
   
   sFilePath = CStr(GuidCacheFileLoc & "rightsGuid.txt")
   
	' Ensure that the folder location exists.  If not, create it.
	If Not oFSO.FolderExists(GuidCacheFileLoc) then
		oFSO.CreateFolder GuidCacheFileLoc
			If Err.number <> 0 then
				Response.Write "Unable to Create Folder: " & GuidCacheFileLoc & "<BR>"
				Response.Write "Error Number: " & Err.number & "<BR>"
				Response.Write "Error description: " & Err.description & "<BR>"
				Response.End 
				Err.Clear
			End If
	End If
   
   If (oFSO.FileExists(sFilePath)) Then
      Set oRightsGuidCache = oFSO.DeleteFile(sFilePath)
      If ((Err.Number = 0) Or (Err.Number = 13) or (Err.Number = 424)) Then
                            '//13 = file has been deleted but system raising a "type mismatch
                            '//error for unknown reasons
                            '//424 = file has been deleted but system raising an
                            '//"object required"
         Err.Clear
         Set oRightsGuidCache = oFSO.CreateTextFile(sFilePath, True, False)
         If Err.Number <> 0 Then
            Response.Write "Error Creating File: "
            Response.Write sFilePath
            Response.Write "<BR>"
            Response.Write " Error Number " & Err.Number
            Response.Write "<BR>"
            Response.Write " Error Description " & Err.Description
            Exit Sub
         End If
      Else
           '//any error number other than 13 or 0 constitutes and error condition
            Response.Write "Error Creating File: "
            Response.Write sFilePath
            Response.Write "<BR>"
            Response.Write " Error Number " & Err.Number
            Response.Write "<BR>"
            Response.Write "Error Description " & Err.Description
            Exit Sub
      End If
   Else
      Set oRightsGuidCache = oFSO.CreateTextFile(sFilePath, True, False)
      If Err.Number <> 0 Then
         Response.Write "Error Creating File: "
         Response.Write sFilePath
         Response.Write "<BR>"
         Response.Write "File did not exist.  Tried to create, but failed"
         Response.Write "<BR>"
         Response.Write "Error Number " & Err.Number
         Response.Write "<BR>" 
         Response.Write "Error Description " & Err.Description
         Exit Sub
      End If

   End If

   
   
   For Each object In oExtendedRightsContainer

      Set oExtendedRightsObject = GetObject("LDAP://" & object.Name & ",cn=extended-rights," & strConfigurationNamingContext)

      strRightsGuid = UCase("{" & oExtendedRightsObject.rightsGuid & "}")

      oRightsGuidCache.WriteLine strRightsGuid & "," & oExtendedRightsObject.Name

      Set oExtendedRightsObject = Nothing
      strRightsGuid = ""

   Next

   oRightsGuidCache.Close
   Response.Write "<strong> OK: "
   Response.Write sFilePath
   Response.Write "</strong>"
   Response.Write "<br><br>"
   Response.Flush 

End Sub

'**********************************************************************
'* Subroutine: CreateSchemaIdGuidCache
'**********************************************************************
Sub CreateSchemaIdGuidCache()

   On Error Resume Next
   
   Dim oRoot, oSchemaContainer, oSchemaObject, oFSO, oSchemaIDGUIDCache, oConverter, object
   Dim strSchemaNamingContext, strSchemaIDGUID, i
   Dim sFilePath

   Response.Write "<strong>Starting: CreateSchemaIdGuidCache"
   Response.Write "<font color=red size=3>"
   Response.Flush 
   
   Set oRoot = GetObject("LDAP://RootDSE")
   strSchemaNamingContext = oRoot.Get("schemaNamingContext")

   Set oSchemaContainer = GetObject("LDAP://" & strSchemaNamingContext)

   Set oFSO = CreateObject("Scripting.FileSystemObject")
   
   sFilePath = CStr(GuidCacheFileLoc & "schemaIDGUID.txt")
   

   If (oFSO.FileExists(sFilePath)) Then
      Set oSchemaIDGUIDCache = oFSO.DeleteFile(sFilePath)
      If ((Err.Number = 0) Or (Err.Number = 13) or (Err.Number = 424)) Then
                            '//13 = file has been deleted but system raising a "type mismatch
                            '//error for unknown reasons
                            '//424 = file has been deleted but system raising an
                            '//"object required"
         Err.Clear
         Set oSchemaIDGUIDCache = oFSO.CreateTextFile(sFilePath, True, False)
         If Err.Number <> 0 Then
            Response.Write "Error Creating File: "
            Response.Write sFilePath
            Response.Write "<BR>"
            Response.Write "Error Number " & Err.Number
            Response.Write "<BR>"
            Response.Write "Error Description " & Err.Description
            Exit Sub
         End If
      Else
           '//any error number other than 13 or 0 constitutes and error condition
            Response.Write "Error Creating File: "
            Response.Write sFilePath
            Response.Write "<BR>"
            Response.Write "Error Number " & Err.Number
            Response.Write "<BR>"
            Response.Write "Error Description " & Err.Description
            Exit Sub
     End If
   Else
      Set oSchemaIDGUIDCache = oFSO.CreateTextFile(sFilePath, True, False)
      If Err.Number <> 0 Then
         Response.Write "Error Creating File: "
         Response.Write sFilePath
         Response.Write "<BR>"
         Response.Write "Error Number " & Err.Number
         Response.Write "<BR>"
         Response.Write "Error Description " & Err.Description
         Exit Sub
      End If
 End If
  
   
   '//Set oSchemaIDGUIDCache = oFSO.CreateTextFile("c:\tmp\schemaIDGUID.txt", True, False)

   Set oConverter = CreateObject("ADsType.Conversion")

   i = 0
   For Each object In oSchemaContainer

      Set oSchemaObject = GetObject("LDAP://" & object.Name & "," & strSchemaNamingContext)

      strSchemaIDGUID = oConverter.StringFromSchemaIDGUID(oSchemaObject.cn)

      '**********************************************************************
      '* BUG: Investigate why I have to trim the right most character from
      '*      the returned schemaIDGUID   ---I suspect it's a bug in the
      '*      ADsType.dll component.
      '**********************************************************************
      strSchemaIDGUID = Left(strSchemaIDGUID, Len(strSchemaIDGUID) - 1)

      oSchemaIDGUIDCache.WriteLine strSchemaIDGUID & "," & oSchemaObject.Name

      Set oSchemaObject = Nothing
      strSchemaIDGUID = ""

      i = i + 1
      'If i Mod 50 = 0 Then List1.AddItem "."
		If i Mod 50 = 0 Then
			Response.Write "."
			Response.Flush 
		End If

   Next

   oSchemaIDGUIDCache.Close
   Response.Write "</strong>"
   Response.Write "</font><strong> OK: "
   Response.Write sFilePath
   Response.Write "</strong>"
   Response.Write "<br><br>"
   Response.Flush
   
End Sub


%>