<%
'********************************************************************
'*				---   Web Admin   ---
'*
'* Created By: Conrad Agramont
'*
'* Logging.asp
'* 
'* Notes:   	
'*			- Any Items marked optional with [braces] need to have a 
'*				blank string passed into the function.
'*
'*			- More Information:  http://www.microsoft.com/ISN
'*
'* Copyright (C) 1999 Microsoft Corporation
'*
'********************************************************************

'*************************
'This sample is provided for educational purposes only. It is not intended to be 
'used in a production environment, has not been tested in a production environment, 
'and Microsoft will not provide technical support for it. 
'*************************


'*************************
'*	COMMON ERROR NUMBERS FOR LOGGING
'*	
'*	0 = Successful
'*	1 = Failed
'*	2 = Warning 
'*	4 = Information
'*	8 = Audit Success
'*	16 = Audit Failure
'*	
'*	32 = Access Denied or Object Does Not Exist
'*	64 = Object Already Exists
'*	128 = 
'*
'*
'*
'*************************

'********************************************************************
'*
'* Function WriteLog(logAction, logResult, logOther)
'* Purpose: Write to a Log File or Database
'* Input:   	logAction			Action that has/will be taken. (String)
'*				logResult			Result of Action. (Integer- See Above)
'*				logOther			Any other information that should be noted. (String)
'*
'* Output:	None
'*
'********************************************************************
Function WriteLog(logAction, logResult, logOther)
On Error Resume Next
' Check to see if Logging is turn on.
If LOGGING_TYPE <> 1 then 
	' Clear All Errors
	'Err.Clear 
	
	' Dim Object
	Dim getThisUser, oFS, txtLog
	
	' Dim Other Variables
	Dim TextLogName, TextLogPath, txtLogInfo
	Dim currentUsersAdsPath, currentUsersRootOU
	Dim	loggingConn, loggingCmd
	Dim WshShell
	
	' Clear Errors Again
	'Err.Clear 
	
	' Check to See what type of logging was selected in Config.asp
	Select Case LOGGING_TYPE
		Case 1
		'***********************
		'* No Logging
		'***********************
		
		Case 2
		'***********************
		'* File System Logging
		'***********************
			' Create the Log Name that will be used.
			TextLogName = "WebAdmin_" & Replace(FormatDateTime(Now(),2),"/","-") & ".txt"
			
			' Create the Full text Log Path
			TextLogPath = LOGGING_FILESYSTEM_LOCATION & TextLogName
			
			' Build New Log information Line.
			txtLogInfo = Now() & ", "
			txtLogInfo = txtLogInfo & """" & curUserObj.Adspath & """, "
			txtLogInfo = txtLogInfo & """" & logAction & """, "
			txtLogInfo = txtLogInfo & """" & logResult & """, "
			txtLogInfo = txtLogInfo & """" & logOther & """"
				If Err.number <> 0 then
					Response.Write "Unable to Build Log String: " & txtLogInfo & "<BR>"
					Response.Write "Error Number: " & Err.number & "<BR>"
					'Response.End 
				End If
			
			' Create the File System Object
			Set oFS = Server.CreateObject("Scripting.FileSystemObject")
				If Err.number <> 0 then
					Response.Write "Unable to Get Scripting Object. <BR>"
					Response.Write "Error Number: " & Err.number & "<BR>"
					Err.Clear 
				End If
			
			' Ensure that the folder location exists.  If not, create it.
			If Not oFS.FolderExists(LOGGING_FILESYSTEM_LOCATION) then
				oFS.CreateFolder LOGGING_FILESYSTEM_LOCATION
					If Err.number <> 0 then
						Response.Write "Unable to Create Folder: " & LOGGING_FILESYSTEM_LOCATION & "<BR>"
						Response.Write "Error Number: " & Err.number & "<BR>"
						Response.Write "Error description: " & Err.description & "<BR>"
						Response.End 
						Err.Clear
					End If
			End If
			
			' Check to see if an File Object has already been created for Today.
			Set txtLog = oFS.OpenTextFile(TextLogPath,8,True)
				If Err.number <> 0 then
					Response.Write "Unable to Open File: " & TextLogPath & "<BR>"
					Response.Write "Error Number: " & Err.number & "<BR>"
					Err.Clear
				End If
			
			' Write Log Information
			txtLog.WriteLine txtLogInfo
				If Err.number <> 0 then
					Response.Write "Unable to Write Line: " & txtLogInfo & "<BR>"
					Response.Write "Error Number: " & Err.number & "<BR>"
					Err.Clear
				Else
					' Close the Document
					txtLog.Close
				End If
			
			' Kill Objects
			Set getThisUser = Nothing
			Set txtLog = Nothing
			Set oFS = Nothing
		
		Case 3
		'***********************
		'* Event Log Logging
		'***********************
			' Build New Log information Line.
			txtLogInfo = Now() & ", "
			txtLogInfo = txtLogInfo & """" & curUserObj.Adspath & """, "
			txtLogInfo = txtLogInfo & """" & logAction & """, "
			txtLogInfo = txtLogInfo & """" & logResult & """, "
			txtLogInfo = txtLogInfo & """" & logOther & """"
				If Err.number <> 0 then
					Response.Write "Unable to Build Event Log String: " & txtLogInfo & "<BR>"
					Response.Write "Error Number: " & Err.number & "<BR>"
					'Response.End 
				End If
			
			' Write Log Information
			Set WshShell = Server.CreateObject("WScript.Shell")
				If Err.number <> 0 then
					Response.Write "Unable to get Object: WScript.Shell"
					Response.Write "Error Description: " & Err.Description & "<BR>"
					Response.Write "Error Number: " & Err.number & "<BR>"
					'Response.End 
				End If
			WshShell.LogEvent 4, txtLogInfo
				If Err.number <> 0 then
					Response.Write "Unable to Write to Event Log: " & txtLogInfo & "<BR>"
					Response.Write "Error Description: " & Err.Description & "<BR>"
					Response.Write "Error Number: " & Err.number & "<BR>"
					'Response.End 
				End If
												
		Case 4
		'***********************
		'* SQL Database Logging
		'***********************
					
			' Build SQL Statement for INSERT
			txtLogInfo = "INSERT LOG VALUES (DEFAULT, '" & Request.ServerVariables("Server_Name")
			txtLogInfo = txtLogInfo & "','" & curUserObj.Guid
			txtLogInfo = txtLogInfo & "','" & EncodeSql(curUserObj.Adspath)
			txtLogInfo = txtLogInfo & "','" & EncodeSql(logAction)
			txtLogInfo = txtLogInfo & "','" & EncodeSql(logResult)
			txtLogInfo = txtLogInfo & "','" & EncodeSql(logOther) & "')"
			
			' Create ADO objects
			Set loggingConn = Application("WebAdmin_ConnectionObject")
			Set loggingCmd = Server.CreateObject("ADODB.Command")

			If Err.Number <> 0 Then
				Response.Write "Unable to open connection to SQL Server <BR>"
				Response.Write "LOGGING_SQL_PROVIDER:" & LOGGING_SQL_PROVIDER &"<BR>"
				Response.Write "Error Description: " & Err.Description & "<BR>"
				Response.Write "Error Number: " & Err.number & "<BR>"
				Response.End 
			End If

			' Build the SQL command
			loggingCmd.Commandtype = 1
			loggingCmd.ActiveConnection = loggingConn
			loggingCmd.CommandText = txtLogInfo
			
			' Execute the SQL Insert (Write Information to Log)
			loggingCmd.Execute
				If Err.number <> 0 then
					Response.Write "Unable to Write to SQL Log: " & txtLogInfo & "<BR>"
					Response.Write "Error Description: " & Err.Description & "<BR>"
					Response.Write "Error Number: " & Err.number & "<BR>"
					Response.End 
				End If
			
			' Kill Objects
			Set loggingConn = Nothing
			Set loggingCmd = Nothing
	End Select
End If 

End Function

%>