<%Option Explicit%>
<!--#Include File="Config.asp" -->
<!--#Include File="Utils.asp" -->
<!--#Include File="Logging.asp" -->
<!--#Include File="PasswordLib.asp" -->
<%
'********************************************************************
'*				---   Web Admin   ---
'*
'* Created By: Conrad Agramont & Ed Tremblay
'*
'* Main.asp
'* 
'* Notes:   	
'*			- Any Items marked optional with [braces] need to have a 
'*				blank string passed into the function.
'*
'*			- More Information:  http://www.microsoft.com/ISN
'*
'* Copyright (C) 1999 Microsoft Corporation
'*
'********************************************************************

'*************************
'This sample is provided for educational purposes only. It is not intended to be 
'used in a production environment, has not been tested in a production environment, 
'and Microsoft will not provide technical support for it. 
'*************************

'* Set Public Variables
Dim rootDSE, sAdsPath, obj, Ldap
Dim UserOuname, UserOU, g_AuthUser, g_OldPassword, g_NewPassword, g_ConfirmPassword
Dim Username, UserObj
Dim ADMIN_FLAG

ADMIN_FLAG = False

'* Set Public Constants
Const SE_DACL_PROTECTED				= &H1000
Const SE_SACL_PROTECTED				= &H2000

Const ADS_PROPERTY_CLEAR			= 1
Const ADS_PROPERTY_UPDATE			= 2
Const ADS_PROPERTY_APPEND			= 3
Const ADS_PROPERTY_DELETE			= 4
    

' rndnum is used very often throught the Web Admin in the querystring.  This way the 
'	browser always thinks it's getting a new page.  The is nessasary because of the 
'	use of location.href in script.
Dim rndnum 

'This is variable is used to specify what the current client is.  If blank, then all 
'	all is set for a regular desktop browser.  Note: Web Admin works only with IE4+
Dim BROWSER_TYPE

' Check for Pocket PC
If Instr(1,Ucase(Request.ServerVariables("HTTP_UA_OS")),"POCKET PC") then
	BROWSER_TYPE = "ppc"
End If

' Check for WAP	
If BROWSER_TYPE = "" and Instr(1,lcase(Request.ServerVariables("HTTP_ACCEPT")),"text/vnd.wap.wml") then
	BROWSER_TYPE = "wap"
End If

' These variables are used within CreateNewOrg
Dim NORMAL_USER_GROUP, ADVANCED_USER_GROUP, ALL_USERS_GROUP, ADMINS_GROUP

'* Set Public Constants -- Proxy User Account Information
'--
'		This is Used for: 
'			- Embedding Org Groups into Master Groups.
'			- To enable Auto Provisioning.
'
'		Note:  It would be best to call this info from a COM object. This 
'					why you can hide the username and password from RAW ASP
'					Code.  Also, create a Proxy user in your Active Directory 
'					that has enough permissions to do what it needs and nothing 
'					more.
'--


'********************************************************************
' Create a Rnd number to ensure the browser & vbscript does not 
'		cache location.href
Randomize 
rndNum =  Int((1000000000000 * Rnd) + 1)
'*
'********************************************************************

'********************************************************************
'*
'* Function IsMemberOf(g_UserGroupObj, g_GroupName)
'* Purpose: Checks to see if a User is a Member of a Given Group
'* Input:   	g_UserGroupObj		List of Groups (Array/String)
'*				groupToBeAdded		ADSPath of Group to Check For. (String)
'*
'* Output:		True/False
'*
'********************************************************************
Function IsMemberOf(g_UserGroupObj, g_GroupName)
On Error Resume Next
	Dim grpName
	IsMemberOf = False
	If typename(g_UserGroupObj) <> "Empty" then
		If typename(g_UserGroupObj) = "String" then
				If lcase(Instr(1,g_UserGroupObj,g_GroupName)) <> 0 then
					IsMemberOf= True
					Exit Function
				Else
					IsMemberOf = False
				End If
		Else
			For Each grpName in g_UserGroupObj
				If lcase(Instr(1,grpName,g_GroupName)) <> 0  then
					IsMemberOf= True
					Exit Function
				Else
					IsMemberOf = False
				End If
			Next
		End If
	End If
DetailError "General Error (IsMemberOf)"
End Function

'********************************************************************
'*
'* Function ListDirectReports(g_UserObj)
'* Purpose: Does a RAW Print of a User's Direct Reports
'* Input:   	g_UserObj		User's Object (ADS Object)
'*				
'* Output:		String
'*
'********************************************************************
Function ListDirectReports(g_UserObj)
On Error Resume Next
	Dim grpName, g_UserGroupObj
	g_UserGroupObj = g_UserObj.directReports
	If typename(g_UserGroupObj) <> "Empty" then
		If typename(g_UserGroupObj) = "String" then
			Response.Write GetUserOutOfAdspath(g_UserGroupObj)
			Response.Write chr(10)
		Else
			For Each grpName in g_UserGroupObj
			Response.Write GetUserOutOfAdspath(grpName)
			Response.Write chr(10)
			Next
		End If
	Else
		Response.Write "<Empty>"
	End IF
DetailError "General Error (ListDirectReports)"
End Function

'********************************************************************
'*
'* Function ListMemberOf(g_UserObj)
'* Purpose: Does a RAW Print of the User's Groups he/she is a Member Of
'* Input:   	g_UserObj		User's Object (ADS Object)
'*				
'* Output:		String
'*
'********************************************************************
Function ListMemberOf(g_UserObj)
On Error Resume Next
	Dim grpName, g_UserGroupObj
	g_UserGroupObj = g_UserObj.memberOf
	If typename(g_UserGroupObj) <> "Empty" then
		If typename(g_UserGroupObj) = "String" then
			Response.Write GetGroupOutOfDN(g_UserGroupObj)
			Response.Write chr(10)
		Else
			For Each grpName in g_UserGroupObj
			Response.Write GetGroupOutOfDN(grpName)
			Response.Write chr(10)
			Next
		End If
	Else
		Response.Write "<Empty>"
	End IF
DetailError "General Error (ListMemberOf)"
End Function


'********************************************************************
'*
'* Function IsAdmin(g_UserGroupObj)
'* Purpose: Check to see if a user is an Organizational Admin
'* Input:   	g_UserGroupObj		User's Object (ADS Object)
'*				
'* Output:  True/False
'*
'********************************************************************
Function IsAdmin(g_UserGroupObj)
On Error Resume Next
	Dim grpName
	
	' Assume user is not an Admin.  Prove me wrong!
	IsAdmin = False
	If typename(g_UserGroupObj) <> "Empty" then
		If typename(g_UserGroupObj) = "String" then
				If lcase(mid(g_UserGroupObj,1,9)) = "cn=admins" then IsAdmin= True
				If lcase(mid(g_UserGroupObj,4,13))	= lcase(constMULTIORGADMIN_GROUP) then IsAdmin= True
				If lcase(mid(g_UserGroupObj,1,25)) = "cn=domain admins,cn=users" then IsAdmin = True
				If lcase(mid(g_UserGroupObj,1,29)) = "cn=enterprise admins,cn=users" then IsAdmin = True
		Else
			For Each grpName in g_UserGroupObj
				If lcase(mid(grpName,1,9)) = "cn=admins" then IsAdmin= True
				If lcase(mid(grpName,4,13))	= lcase(constMULTIORGADMIN_GROUP) then IsAdmin= True
				If lcase(mid(grpName,1,25)) = "cn=domain admins,cn=users" then IsAdmin = True
				If lcase(mid(grpName,1,29)) = "cn=enterprise admins,cn=users" then IsAdmin = True
			Next
		End If
	End If
DetailError "General Error (IsAdmin)"
End Function

'********************************************************************
'*
'* Function IsMultiOrgAdmin(g_UserGroupObj)
'* Purpose: Check to see if a user is a Multi Org Admin.
'* Input:   	g_UserGroupObj		User's Object (ADS Object)
'*				
'* Output:  True/False
'*
'********************************************************************
Function IsMultiOrgAdmin(g_UserGroupObj)
On Error Resume Next
	Dim grpName
	
	' Assume user is not an Admin.  Prove me wrong!
	IsMultiOrgAdmin = False
	If typename(g_UserGroupObj) <> "Empty" then
		If typename(g_UserGroupObj) = "String" then
				If lcase(mid(g_UserGroupObj,4,14))	= lcase(constMULTIORGADMIN_GROUP) then IsMultiOrgAdmin= True
				If lcase(mid(g_UserGroupObj,1,25)) = "cn=domain admins,cn=users" then IsMultiOrgAdmin = True
				If lcase(mid(g_UserGroupObj,1,29)) = "cn=enterprise admins,cn=users" then IsMultiOrgAdmin = True
		Else
			For Each grpName in g_UserGroupObj
				If lcase(mid(grpName,4,14))	= lcase(constMULTIORGADMIN_GROUP) then IsMultiOrgAdmin= True
				If lcase(mid(grpName,1,25)) = "cn=domain admins,cn=users" then IsMultiOrgAdmin = True
				If lcase(mid(grpName,1,29)) = "cn=enterprise admins,cn=users" then IsMultiOrgAdmin = True
			Next
		End If
	End If
DetailError "General Error (IsMultiOrgAdmin)"
End Function


'********************************************************************
'*
'* Function IsMultiOrgAdminStrict(g_UserGroupObj)
'* Purpose: Check to see if a user is a Multi Org Admin. Domain Admin
'*				or Enterprise Admins do not count.
'* Input:   	g_UserGroupObj		User's Object (ADS Object)
'*				
'* Output:  True/False
'*
'********************************************************************
Function IsMultiOrgAdminStrict(g_UserGroupObj)
On Error Resume Next
	Dim grpName
	
	' Assume user is not an Admin.  Prove me wrong!
	IsMultiOrgAdminStrict = False
	If typename(g_UserGroupObj) <> "Empty" then
		If typename(g_UserGroupObj) = "String" then
				If lcase(mid(g_UserGroupObj,4,14))	= lcase(constMULTIORGADMIN_GROUP) then IsMultiOrgAdminStrict= True
		Else
			For Each grpName in g_UserGroupObj
				If lcase(mid(grpName,4,14))	= lcase(constMULTIORGADMIN_GROUP) then IsMultiOrgAdminStrict= True
			Next
		End If
	End If
DetailError "General Error (IsMultiOrgAdminStrict)"
End Function

'********************************************************************
'*
'* Function IsDomAdmin(g_UserGroupObj)
'* Purpose: Check to see if a user is an admin greater then Organizational Admin
'* Input:   	g_UserGroupObj		User's Object (ADS Object)
'*				
'* Output:  True/False
'*
'********************************************************************
Function IsDomAdmin(g_UserGroupObj)
On Error Resume Next
	Dim grpName
	
	' Assume user is not an Admin.  Prove me wrong!
	IsDomAdmin = False
	If typename(g_UserGroupObj) <> "Empty" then
		If typename(g_UserGroupObj) = "String" then
				If lcase(mid(g_UserGroupObj,1,25)) = "cn=domain admins,cn=users" then IsDomAdmin = True
				If lcase(mid(g_UserGroupObj,1,29)) = "cn=enterprise admins,cn=users" then IsDomAdmin = True
		Else
			For Each grpName in g_UserGroupObj
				If lcase(mid(grpName,1,25)) = "cn=domain admins,cn=users" then IsDomAdmin = True
				If lcase(mid(grpName,1,29)) = "cn=enterprise admins,cn=users" then IsDomAdmin = True
			Next
		End If
	End If
DetailError "General Error (IsDomAdmin)"
End Function

'********************************************************************
'*
'* Function AllowUserEnableService()
'* Purpose: Check to see if the user object passed is able to enable 
'*					services
'* Input:   	None
'*				
'* Output:  True/False
'*
'********************************************************************
Function AllowAdminEnableService()
On Error Resume Next
	Dim strAuth_User, g_curUserObj
	
	' Assume the Answer is False, prove me wrong
	AllowAdminEnableService = False
	
	' Get Current User Object
	strAuth_User	= Request.ServerVariables("Auth_User")
	Set g_curUserObj =  GetAuthUserInfo(strAuth_User)
	
	If ALLOW_ADMINS_ENABLE_SERVICE Then
		If IsAdmin(g_curUserObj.memberof) then
			AllowAdminEnableService = True
		End If
	Else
		If IsDomAdmin(g_curUserObj.memberof) then
			AllowAdminEnableService = True
		End If
	End If
	
DetailError "General Error (AllowAdminEnableService)"
End Function

'********************************************************************
'*
'* Function IsInGroup(g_UserGroupObj,g_GroupName)
'* Purpose: Check to see if a user is in a given group
'* Input:   	g_UserGroupObj		User's Object (ADS Object)
'*				g_GroupName			AdsPath of Group to check for.
'*										
'* Output:  True/False
'*
'********************************************************************
Function IsInGroup(g_UserGroupObj,g_GroupName)
On Error Resume Next
	Dim grpName
	IsInGroup = False
	If typename(g_UserGroupObj) <> "Empty" then
		If typename(g_UserGroupObj) = "String" then
				If lcase(grpName) = lcase(g_GroupName) then
					IsInGroup= True
					Exit Function
				Else
					IsInGroup = False
				End If
		Else
			For Each grpName in g_UserGroupObj
				If lcase(grpName) = lcase(g_GroupName) then
					IsInGroup= True
					Exit Function
				Else
					IsInGroup = False
				End If
			Next
		End If
	End If
DetailError "General Error (IsInGroup)"
End Function

'********************************************************************
'*
'* Function GroupExist(g_UserGroupObj,g_GroupName)
'* Purpose: Check to see if an object is in given Contianer
'* Input:   	objContainer		Container to look within (Object)
'*				strItem				Name of object you are checking for (String)
'*										
'* Output:  True/False
'*
'********************************************************************
Function GroupExist(objContainer,strItem)
On Error Resume Next
	Dim Item
	GroupExist = False
		For Each Item in objContainer
			If lcase(strItem) = lcase(Item.name) then
				GroupExist = True
			End If
		Next
DetailError "General Error (GroupExist)"
End Function

'********************************************************************
'*
'* Function UsersInGroupCount(varGroupAdsPath)
'* Purpose: Get a Count of members in a Group.
'* Input:   	varGroupAdsPath		Group ADS Path
'*				
'* Output:  Integer
'*
'********************************************************************
Function UsersInGroupCount(varGroupAdsPath)
On Error Resume Next
	Dim Target_Group, Group_Counter, grpName
	UsersInGroupCount = 0
	Group_Counter = 0
	Set Target_Group = GetObject(varGroupAdsPath)
	DetailError "Could not Get Access to Object.  Object does not exist or Access is Denied (UsersInGroupCount)"
	
	If typename(Target_Group) <> "Empty" then
		If lcase(typename(Target_Group)) = "string" then
			UsersInGroupCount = 1
		Else
			For Each grpName in Target_Group.members
				Group_Counter = Group_Counter + 1
				UsersInGroupCount = Group_Counter
			Next
		End If
	End If
	
	' Kill Ojects
	Set Target_Group = Nothing
DetailError "General Error (UsersInGroupCount)"
End Function

'********************************************************************
'*
'* Function RenameUser(CurrentAdsPathOfObject, TargetContainerAdsPath, NewNameOfObject)
'* Purpose: Rename a User.
'* Input:   	CurrentAdsPathOfObject		Current Adspath of Object (String)
'*				TargetContainerAdsPath		
'*				NewNameOfObject					
'*										
'* Output:  String - Objects New Ads Path of User
'*
'********************************************************************
Function RenameUser(CurrentAdsPathOfObject, TargetContainerAdsPath, NewNameOfObject)
'On Error Resume Next

	'Dim Objects
	Dim UserObject

	' Dim Variables
	Dim n_user_adspath, tempUPNSuffix, usersNewUpn, newSamAccountName
	
	' Rename the Users Object
	n_user_adspath = MoveObject(CurrentAdsPathOfObject, TargetContainerAdsPath, "CN=" &  NewNameOfObject)
		If Err.number <> 0 then
			Exit Function
		End If
		
	' Get the New User's Object
	Set UserObject = GetObject(n_user_adspath)
		
	' Set the Users new User Principal Name Suffix
	tempUPNSuffix = GetRootOU(CurrentAdsPathOfObject)
	
	' Set the Users new User Principal Name
	usersNewUpn = NewNameOfObject & "@" & tempUPNSuffix
	UserObject.userPrincipalName = cstr(usersNewUpn)
	
	' Check to See if the Web Admin Tool is set for use in a Service Provider Environement
	If ASP_SERVICES_ENABLED Then
		
		' Set the Users new User Principal Name Suffix
		tempUPNSuffix = GetRootOU(CurrentAdsPathOfObject)
	
		' Set the Users new User Principal Name
		usersNewUpn = NewNameOfObject & "@" & tempUPNSuffix
	
		If UpnExist(usersNewUpn) Then
				Err.description = "User Already Exists"
			Exit Function
		End If
		
		UserObject.userPrincipalName = cstr(usersNewUpn)		
		
		' The SAM name must not exeed 20 Charactors.  User will never use this, but we still 
		'	want it to be descriptive and short.  The OU name is put in front, but must not 
		'	exceed 8 charactors.  The GetUniqueSamName will return bace a unique username to 
		'	use.
		newSamAccountName = GetUniqueSamName(Mid(tempUPNSuffix,1,10) & "_" & NewNameOfObject)
		UserObject.put "samAccountName", newSamAccountName
	Else
		UserObject.userPrincipalName = cstr(NewNameOfObject)
		UserObject.put "samAccountName", NewNameOfObject
	End If
	
	'Save the Information to the Directory
	UserObject.SetInfo
	
	' Write to Log
	WriteLog "RenameUser",0, "Old User: " & CurrentAdsPathOfObject & chr(10) & "New User: " & UserObject.AdsPath
	
	' Return the Adspath
	RenameUser = UserObject.AdsPath
	
	' Destroy Objects
	Set UserObject = Nothing
	
	
End Function



'********************************************************************
'*
'* Function GetSchemaObject(strSchemaObjName, strSchemaObjType)
'* Purpose: Get the Schema Object and return it.
'* Input:   	strSchemaObjName		name of the Schema Object (String)
'*				strSchemaObjType		Type of Object (String)
'*										
'* Output:  Object - Return the Schema Object Requested
'*
'********************************************************************
Function GetSchemaObject(strSchemaObjName, strSchemaObjType)
	' Dim Objects
	Dim objSchemaObj
	Dim objRootDSE
	Dim tempSchemaObj
	
	' Get the RootDSE Object
	Set objRootDSE = GetObject("LDAP://rootDSE")
	
	' Get the Schema Container
	Set objSchemaObj		= GetObject("LDAP://" & objRootDSE.get("schemaNamingContext"))
	
	' Get the Object Requested
	Set tempSchemaObj		= objSchemaObj.GetObject(strSchemaObjType, "CN=" & strSchemaObjName)
		
	' Return the Object
	Set GetSchemaObject		= tempSchemaObj
	
	' Kill Object
	Set objRootDSE			= Nothing
	Set objSchemaObj		= Nothing
	Set tempSchemaObj		= Nothing
End Function

'********************************************************************
'*
'* Function MoveObject(CurrentAdsPathOfObject, TargetContainerAdsPath, NewNameOfObject)
'* Purpose: Move a User from one OU to Another.
'* Input:   	CurrentAdsPathOfObject		Current Adspath of Object (String)
'*				TargetContainerAdsPath		
'*				NewNameOfObject					
'*										
'* Output:  String - Objects New Ads Path
'*
'********************************************************************
Function MoveObject(CurrentAdsPathOfObject, TargetContainerAdsPath, NewNameOfObject)
'On Error Resume Next
	Dim objTargetContainer, objNewObj
	Dim tempUserADSPath, tempUserCN
	
	' Get the container for which the user object will be moving to.
	Set objTargetContainer = GetObject(TargetContainerAdsPath)
	DetailError "Could not Get Access to Object Container.  Object does not exist or Access is Denied (MoveObject)"
		
	' Proceed to Move the User Object
	Set objNewObj = objTargetContainer.MoveHere(CurrentAdsPathOfObject, NewNameOfObject)
	DetailError "Could not Move the Object.  (MoveObject)"
	
	' Write to Log
	WriteLog "MoveObject",0, "Old Location:" & CurrentAdsPathOfObject & " :: New Location:" & objNewObj.AdsPath
	
	'Return the New ADS Path for the given User Object
	MoveObject = objNewObj.AdsPath
	
	' Kill Ojects
	Set objTargetContainer	= Nothing
	Set objNewObj			= Nothing
End Function


'********************************************************************
'*
'* Function CopyObject(SourceAdsPathOfObject, TargetContainerAdsPath, NewNameOfObject)
'* Purpose: Copy and Object
'* Input:   	SourceAdsPathOfObject		Source Adspath of Object (String)
'*				TargetContainerAdsPath		Target Container Adspath of new Object (String)
'*				NewNameOfObject				Name of the New Object (String)		
'*										
'* Output:  String - Objects New Ads Path
'*
'********************************************************************
Function CopyObject(SourceAdsPathOfObject, TargetContainerAdsPath, NewNameOfObject)
'On Error Resume Next
	Dim objTargetContainer, objNewObj
	Dim tempUserADSPath
	
	Response.Write "SourceAdsPathOfObject: " & SourceAdsPathOfObject & "<BR>"
	Response.Write "TargetContainerAdsPath: " & TargetContainerAdsPath & "<BR>"
	Response.Write "NewNameOfObject: " & NewNameOfObject & "<BR>"
	Response.End 
	
	' Get the container for which the user object will be moving to.
	Set objTargetContainer = GetObject(TargetContainerAdsPath)
	DetailError "Could not Get Access to Object Container.  Object does not exist or Access is Denied (CopyObject)"
		
	' Proceed to Move the User Object
	Set objNewObj = objTargetContainer.CopyHere(SourceAdsPathOfObject, "CN=" & NewNameOfObject)
	DetailError "Could not Move the Object.  (CopyObject)"
	
	' Write to Log
	WriteLog "CopyObject",0, "Old Location:" & CurrentAdsPathOfObject & " :: New Location:" & objNewObj.AdsPath
	
	'Return the New ADS Path for the given User Object
	MoveObject = objNewObj.AdsPath
	
	' Kill Ojects
	Set objTargetContainer	= Nothing
	Set objNewObj			= Nothing
End Function

'********************************************************************
'*
'* Function MoveUser(gUser_adsPath, gAdsPath)
'* Purpose: Move a User from one OU to Another.
'* Input:   	gUser_adsPath		Ads Path of User
'*				gAdsPath			AdsPath of the New Container Location.
'*										
'* Output:  String - User Objects New ADS Path
'*
'********************************************************************
Function MoveUser(gUser_adsPath, gAdsPath)
On Error Resume Next
	Dim objUser, objTargetContainer, objNewObj
	Dim tempUserADSPath, tempUserCN
	
	'Get the User Object
	Set objUser = GetObject(gUser_adsPath)
	DetailError "Could not Get Access to Object.  Object does not exist or Access is Denied (MoveUser)"
	
	' Get the container for which the user object will be moving to.
	Set objTargetContainer = GetObject(gAdsPath)
	DetailError "Could not Get Access to Object Container.  Object does not exist or Access is Denied (MoveUser)"
		
		' Set Temp Variables for the User's Current ADSPath and CN
		tempUserADSPath = objUser.AdsPath
		tempUserCN = "CN=" & objUser.CN
		
	' Proceed to Move the User Object
	Set objNewObj = objTargetContainer.MoveHere(tempUserADSPath,tempUserCN)
	DetailError "Could not Move the Object.  (MoveUser)"
	
	' Write to Log
	WriteLog "MoveUser",0, "Old Location:" & gUser_adsPath & " :: New Location: " & objNewObj.AdsPath
		
	'Return the New ADS Path for the given User Object
	MoveUser = objNewObj.AdsPath
	
	' Kill Ojects
	Set objUser				= Nothing
	Set objTargetContainer	= Nothing
	Set objNewObj			= Nothing
End Function


'********************************************************************
'*
'* Function MoveOU(gOU_adsPath, gAdsPath)
'* Purpose: Move an OU from one Container to Another.
'* Input:   	gOU_adsPath			Ads Path of the OU to be moved
'*				gAdsPath			AdsPath of the New Container.
'*										
'* Output:  String - OU's New ADS Path
'*
'********************************************************************
Function MoveOU(gOU_adsPath, gAdsPath)
On Error Resume Next
	Dim objUser, objTargetContainer, objNewObj
	Dim tempOUADSPath, tempOU
	
	' Get the OU Object
	Set objUser = GetObject(gOU_adsPath)
	DetailError "Could not Get Access to Object.  Object does not exist or Access is Denied (MoveOU)"
	
	' Get the container for which the OU Object will be moving to.
	Set objTargetContainer = GetObject(gAdsPath)
	DetailError "Could not Get Access to Object.  Object does not exist or Access is Denied (MoveOU)"
		
		' Set Temp Variables for the OU's Current ADSPath and OU
		tempOUADSPath = objUser.AdsPath
		tempOU = "OU=" & objUser.ou
		
	' Proceed to Move the OU Object
	Set objNewObj = objTargetContainer.MoveHere(tempOUADSPath,tempOU)
	DetailError "Could not Move the Object (MoveOU)"
	
	' Write to Log
	WriteLog "MoveOU",0, "Old Location:" & gOU_adsPath & " :: New Location: " & objNewObj.AdsPath
			
	'Return the New ADS Path for the given OU Object
	MoveOU = objNewObj.AdsPath
	
	' Kill Ojects
	Set objUser				= Nothing
	Set objTargetContainer	= Nothing
	Set objNewObj			= Nothing
End Function

'********************************************************************
'*
'* Function CreateNewChildOrg(sOrgName, sOrgParent)
'* Purpose: Creates a New OU in an existing OU.
'* Input:   	sOrgName		Name of the New Group
'*				sOrgParent		AdsPath of Group the Parent Group
'*
'* Output:  New Child OU AdsPath (String)
'*
'********************************************************************
Function CreateNewChildOrg(sOrgName, sOrgParent)
'On Error Resume Next
	Dim sAdServer, sOuObj, SecurityDescriptor, Dacl
	
	' Get the Parent Container
	Set sAdServer = GetObject(sOrgParent)
	DetailError "Could not Get Access to Object.  Object does not exist or Access is Denied (CreateNewChildOrg)"
	
	' Create the new Organization
	Set sOuObj = sAdServer.Create("organizationalUnit", "OU=" & sOrgName)
	DetailError "Could not Create the New Child OU.  There may be another OU by the same name in the same container. (CreateNewChildOrg)"
	'Response.Write sOrgName
	'Response.End 
	' Save information to the Directory
	sOuObj.SetInfo
	
	' Check to see if ASP Services is Enabled
	If ASP_SERVICES_ENABLED Then
		' Set Proper Ace Entries
		Set SecurityDescriptor = sOuObj.Get("ntSecurityDescriptor")
		'DetailError "Unable to Access the SecurityDescriptor or Access is Denied (ResetASPSecurity)"
	
		Set Dacl = SecurityDescriptor.DiscretionaryAcl
		'DetailError "Unable to Access the DiscretionaryAcl or Access is Denied (ResetASPSecurity)"
	
		' Remove the ability for any user in the Directory to access this
		'	OU or its object
		DeleteAce dacl, "NT AUTHORITY\Authenticated Users"
		'Response.Write "Deleting ACE: NT AUTHORITY\Authenticated Users"
	
		'*** Add New Dacl to the Security Descriptor
		SecurityDescriptor.discretionaryAcl = dacl
		sOuObj.put "ntSecurityDescriptor", SecurityDescriptor
	
		' Save Information
		sOuObj.SetInfo
		DetailError "Unable to Save the creation of the New Child OU (CreateNewChildOrg)"
	End If 
	
	' Write to Log
	WriteLog "CreateNewChildOrg",0, "New Org: " & sOrgName & chr(10) & "Parent: " & sOrgParent
	
	'Return the AdsPath of the New Object
	CreateNewChildOrg = sOuObj.AdsPath
	
	' Kill Ojects
	Set sAdServer				= Nothing
	Set sOuObj					= Nothing
End Function

Function GetProxyObject(TargetAdspath)
	' Get Ldap Object
	Set LdapObj = GetObject("LDAP:")
	
	' Get the Object and Pass it back
	Set GetProxyLdapObject = LdapObj.OpenDsObject(_
					TargetAdspath, _
					PROXY_USERNAME, _
					PROXY_USERNAME_PASSWORD, _
					1)
End Function

'********************************************************************
'*
'* Function CreateNewOrg(sOrgName, sOuDesc, sManagingOrg, bnMultiOrgAdmin, sAuthType)
'* Purpose: Create a new ROOT Organization
'* Input:   	sOrgName		Organization Name (String)
'*				sOuDesc			Description of the Organization (String)
'*				sManagingOrg	Name of Group that will be allowed to 
'*								manage this new Org. (String)
'*				bnMultiOrgAdmin	Will this new OU be able to create other OU's
'*								(True/False)
'*				sAuthType		Security Authentication Switch. User current
'*								user security context, or Impersonate(1) (Int)
'*									sAuthType - NOT YET Implemented.
'*										 
'* Output:  String - Adspath of the New Org
'*
'********************************************************************
Function CreateNewOrg(sOrgName, sOuDesc, sManagingOrg, bnMultiOrgAdmin, sAuthType)
On Error Resume Next
	Dim sAdServer, sOuObj, sMpcFlag, SecurityDescriptor, Dacl
	Dim ldapDomainName, adminGroupAdspath, multiOrgAdminGroupAdspath, allUserGroupAdsPath
	Dim multiOrgAdminAdspath
	
	' Get the domain that this OU will exist
	ldapDomainName = GetDomain()
	
	' Check to see if ASP Services is Enabled
	If ASP_SERVICES_ENABLED Then
		sAdsPath = "LDAP://OU=" & HOSTING_OU & "," & ldapDomainName
	Else
		sAdsPath = "LDAP://" & ldapDomainName
	End If
	
	' Check to see what security context to use when creating this Org.	
	If sAuthType = 1 then
		' Get the Root Domain via Proxy/Impersonate User Connection
		GetProxyObject sAdsPath
	Else
		' Get the Root Domain
		Set sAdServer = GetObject(sAdsPath)
		DetailError "Unable to Access the Directory or Access is Denied (CreateNewOrg)"
	End If
	
	' Create the New Organization.
	Set sOuObj = CreateOU(sAdServer, sOrgName, sOuDesc)
		Select Case Err.number
			Case 424
				Exit Function
			Case -2147019886
				WriteLog "CreateNewOrg",64, "Tried to Create:" & sOrgName
				' Bubble Up Error
				Exit Function
		End Select
		DetailError("Unable to Create New OU.  You may not have access to perform this function. (CreateNewOrg)")
	
	' Save Information to the Directory
	sOuObj.SetInfo
		If Err.number = -2147019886 then
			WriteLog "CreateNewOrg",64, "Tried to Create:" & sOrgName
			' The WriteLog Function is going to clear some errors, so let's put it back in.
			Err.number = -2147019886 
			' Bubble Up Error
			Exit Function
		End If
	DetailError "Unable to Do initial Save of New OU.  You may not have access to perform this function. (CreateNewOrg)"
	
		' Create Organizational Groups for Service Use
		CreateGroup sOuObj, constNORMAL_USER_GROUP & sOrgName , "Normal User Account Group" , "LDAP://CN=" & MASTER_GROUP_ALLNORMAL & ",OU=" & SERVICES_OU & "," & ldapDomainName
		CreateGroup sOuObj, constALL_USERS_GROUP & sOrgName , "All Users Account Group", "LDAP://CN=" & MASTER_GROUP_ALLUSERS & ",OU=" & SERVICES_OU & "," & ldapDomainName
		CreateGroup sOuObj, constADVANCED_USER_GROUP & sOrgName , "Advanced User Account Group", "LDAP://CN=" & MASTER_GROUP_ALLADVUSERS & ",OU=" & SERVICES_OU & "," & ldapDomainName
		adminGroupAdspath = CreateGroup(sOuObj, constADMINS_GROUP & sOrgName , "Admins Account Group", "LDAP://CN=" & MASTER_GROUP_ALLADMINS & ",OU=" & SERVICES_OU & "," & ldapDomainName)
		
		'If this set to allow the creation of other OU's, then create a group in this new
		'	OU.  This new group will be used as an identifier that will allow Org Admins
		'	of this OU to create and manage only Organizations that it created.  This new
		'	group will also be embedded to a Master Service Group for tracking.  Now all 
		'	of this is really tricky, because all is dependant on the group just exising
		'	within this Org to allow it to create New Orgs.  Once those Orgs are created,
		'	ACL settings allow the Org Admins of this Org to manage the new org it created.
		'	So after creation, the group no longer plays a role except to create new Orgs.
		If bnMultiOrgAdmin Then
			multiOrgAdminAdspath = CreateGroup(sOuObj, constMULTIORGADMIN_GROUP & sOrgName , "Multi Org Admin Identifier Account Group", "LDAP://CN=" & MASTER_GROUP_ALLMULTIORGADMIN & ",OU=" & SERVICES_OU & "," & ldapDomainName)
			' Nest the MuliOrg Admin Group in the Admins Group.  This Is optional.
			'AddToGroup adminGroupAdspath, multiOrgAdminGroupAdspath
		End If
		
		' if the sManagingOrg was passed in (not blank) then that group should be give the same 
		'	rights as the Org Admins of this new org.
		If sManagingOrg <> "" then
			' Set Proper Ace Entries
				Set SecurityDescriptor = sOuObj.Get("ntSecurityDescriptor")
				'DetailError "Unable to Access the SecurityDescriptor or Access is Denied (CreateNewOrg)"
	
				Set Dacl = SecurityDescriptor.DiscretionaryAcl
				'DetailError "Unable to Access the DiscretionaryAcl or Access is Denied (CreateNewOrg)"
	
				' Give the Managing OU Group Full Access to this new Org.
				' CHEAT Sheet: AddAce(TrusteeName, gAccessMask, gAceType, gAceFlags, gFlags, gObjectType, gInheritedObjectType)
				AddAce dacl, sManagingOrg, 983551, 0, 2, 0, 0, 0
				AddAce dacl, sManagingOrg, 786733, 0, 18, 0, 0, 0
	
				'*** Add New Dacl to the Security Descriptor
				SecurityDescriptor.discretionaryAcl = dacl
				sOuObj.put "ntSecurityDescriptor", SecurityDescriptor
	
			'Save with new Security Settings
			sOuObj.SetInfo
		End If
		
		' This is set for future use.
		If sMpcFlag = 1 then
			CreateGroup sOuObj, "ManagedPc@" & sOrgName , "Managed PC Client Account Group", ""
			CreateGroup sOuObj, "ManagedServer@" & sOrgName , "Managed Edge Server Account Group", ""
		End If
		
		' Set Security on this new ROOT OU
		ResetASPSecurity sOuObj, sOrgName
			' Error Handling done at the called Function.
	
	' Save Information to the Directory
	sOuObj.SetInfo
	DetailError "Unable to Save New OU.  You may not have access to perform this function. (CreateNewOrg)"
	
	' Write success to log.
	WriteLog "CreateNewOrg",0, "Created: " & sOrgName
	
	' Return the New Org Adspath
	CreateNewOrg = sOuObj.adspath
	
	' Kill Objects
	Set rootDSE							= Nothing
	Set sAdServer						= Nothing
	Set sOuObj							= Nothing
	Set SecurityDescriptor				= Nothing
	Set Dacl							= Nothing

End Function

'********************************************************************
'*
'* Function ResetASPSecurity(sOuObj)
'* Purpose: Set/Reset Security on Parent OU.
'* Input:   	sOuObj		Target Container (Object)
'*										 
'* Output:  None
'*
'********************************************************************
Function ResetASPSecurity(sOuObj, sOrgName)
On Error Resume Next
	Dim SecurityDescriptor, Dacl, x
	
		' Set Proper Ace Entries
		Set SecurityDescriptor = sOuObj.Get("ntSecurityDescriptor")
		DetailError "Unable to Access the SecurityDescriptor or Access is Denied (ResetASPSecurity)"
	
		Set Dacl = SecurityDescriptor.DiscretionaryAcl
		DetailError "Unable to Access the DiscretionaryAcl or Access is Denied (ResetASPSecurity)"
	
		' Check to See if the Web Admin Tool is set for use in a Service Provider Environement
		If ASP_SERVICES_ENABLED Then
	
			' Remove the ability for any user in the Directory to access this
			'	OU or its object
			DeleteAce dacl, "NT AUTHORITY\Authenticated Users"		
			
		End If
		' Remove any leftover security setting, in case this is a RESET
		'		Reset Admins
		DeleteAce dacl, "Admins@" & sOrgName
		
		'		Reset AllUsers
		DeleteAce dacl, "AllUsers@" & sOrgName

		' Allow Users from within this OU to view other members in the same Org
		' CHEAT Sheet: AddAce(TrusteeName, gAccessMask, gAceType, gAceFlags, gFlags, gObjectType, gInheritedObjectType)
		AddAce dacl, "AllUsers@" & sOrgName, 131092, 0, 2, 0, 0, 0
		DetailError "Unable to Delete an ACE (ResetASPSecurity)"
		
		' Allow Users from within this OU to view other members in the same Org
		' This Entry is added in incase the constant LIST_OBJECT_MODE_ON is set to true.
		'	Even if it is not, just in case the AD changes modes later, this setting 
		'	is there still providing service.  This setting sets List Object for 
		'	AllUsers@<orgname>.
		AddAce dacl, "AllUsers@" & sOrgName, 128, 0, 0, 0, 0, 0
		DetailError "Unable to Delete an ACE (ResetASPSecurity)"
	
		' ////
		' //// Allow the Admins of this OU to do SOME Delegated tasks
		' ////
	
		'*** Create/Delete User Objects
		' This object and all child objects, (Create User Objects, Delete User Objects)
		AddAce dacl, "Admins@" & sOrgName, 3, 5, 2, 1, "{BF967ABA-0DE6-11D0-A285-00AA003049E2}", 0
		DetailError "Unable to Add an ACE (ResetASPSecurity)"
		
		'*** Full Control of User Objects
		' User Object, (Full Control)
		AddAce dacl, "Admins@" & sOrgName, 983551, 5, 10, 2, 0, "{BF967ABA-0DE6-11D0-A285-00AA003049E2}"
		DetailError "Unable to Add an ACE (ResetASPSecurity)"
	
		'*** Reset User Passwords
		' User Objects, (Reset Password)
		AddAce dacl, "Admins@" & sOrgName, 256, 5, 10, 3, "{00299570-246D-11D0-A768-00AA006E0529}", "{BF967ABA-0DE6-11D0-A285-00AA003049E2}"
		DetailError "Unable to Add an ACE (ResetASPSecurity)"
	
		'*** Create & Delete Groups
		' This object and all child objects, (Create Group Objects, Delete Group Objects)
		AddAce dacl, "Admins@" & sOrgName, 3, 5, 2, 1, "{BF967A9C-0DE6-11D0-A285-00AA003049E2}", 0
		DetailError "Unable to Add an ACE (ResetASPSecurity)"
	
		'*** Full Control of Groups
		' Group Objects, (Full Control)
		AddAce dacl, "Admins@" & sOrgName, 983551, 5, 10, 2, 0, "{BF967A9C-0DE6-11D0-A285-00AA003049E2}"
		DetailError "Unable to Add an ACE (ResetASPSecurity)"
	
		'*** Modify the Membership of Groups
		AddAce dacl, "Admins@" & sOrgName, 48, 5, 10, 3, "{BF9679C0-0DE6-11D0-A285-00AA003049E2}", "{BF967A9C-0DE6-11D0-A285-00AA003049E2}"
		DetailError "Unable to Add an ACE (ResetASPSecurity)"
	
		'*** Create & Delete Organizational Units
		' This object and all child objects, (Create Organizational Unit, Delete Organizational Unit)
		AddAce dacl, "Admins@" & sOrgName, 3, 5, 2, 1, "{BF967AA5-0DE6-11D0-A285-00AA003049E2}", 0
		DetailError "Unable to Add an ACE (ResetASPSecurity)"
		
		'*** Full Control of Organizational Units
		' Organizational Unit, (Full Control)
		AddAce dacl, "Admins@" & sOrgName, 983551, 5, 10, 2, 0,"{BF967AA5-0DE6-11D0-A285-00AA003049E2}"
		DetailError "Unable to Add an ACE (ResetASPSecurity)"
		
		'*** Write Properties to the Root OU Object Only
		' This Object, (Write Properties)
		AddAce dacl, "Admins@" & sOrgName, 32, 0, 0, 0, 0, 0
		DetailError "Unable to Add an ACE (ResetASPSecurity)"
	
		'*** Add New Dacl to the Security Descriptor
		SecurityDescriptor.discretionaryAcl = dacl
		sOuObj.put "ntSecurityDescriptor", SecurityDescriptor
		DetailError "Unable to Set the SecurityDescriptor or Access is Denied (ResetASPSecurity)"
		

End Function

'********************************************************************
'*
'* Function CreateOU(sAdServer, cOuName, sOuDesc)
'* Purpose: Create an OU.
'* Input:   	sAdServer		Parent Container (Object)
'*				cOuName			Name of new OU (String)
'*				sOuDesc			Description of the Organization (String)
'*										 
'* Output:  Object  - The Function will pass back the Newly created OU.
'*
'********************************************************************

Function CreateOU(sAdServer, cOuName, sOuDesc)
On Error Resume Next
	Dim cNewOrg
	
	' Create the New OU
	Set cNewOrg = sAdServer.Create("organizationalUnit", "OU=" & cOuName)
		' Bubble Errors UP!
		'DetailError "Unable to Create OU.  You may not have access to perform this function. (CreateOU)"
		If Err.number <> 0 then
			Exit Function
		End If
		
	' Check to see if the OU Description needs to be set.
	If sOuDesc <> "" then 
		cNewOrg.Description = sOuDesc
	End If
	
	' Set the Info.  If you don't do this here, the creation will not be complete
	cNewOrg.SetInfo
	If Err.number <> 0 then
			Exit Function
		End If
		' Bubble Errors UP!
		'DetailError "Unable to Save OU for Creation.  This Object may already exist or you do not have access to perform this function. (CreateOU)"
	Set CreateOU = cNewOrg
	
	' Write to Log
	WriteLog "CreateOU",0, "Created: " & cOuName & chr(10) & "Parent: " & sAdServer.AdsPath
	
	' Kill Objects
	Set cNewOrg = Nothing
End Function

'********************************************************************
'*
'* Function SetHostingSecurity(HostingAdspath,strAllUserMasterGroup)
'* Purpose: Sets the security for the Main Hosting OU.
'* Input:   	HostingAdspath				Adspath to the Hosting OU (Object)
'*				strAllUserMasterGroup		AdsPath to the All User Master Group. (String)
'*										 
'* Output:  Object  - The Function will pass back the Newly created OU.
'*
'********************************************************************
Function SetHostingSecurity(HostingAdspath,strAllUserMasterGroup)
' Bubble UP Errors to calling
	Dim objHostingOU, SecurityDescriptor, Dacl, x
			'LIST_OBJECT_MODE_ON
		' Get Hosting OU
		Set objHostingOU = GetObject(HostingAdspath)
			If Err.number <> 0 then
				Response.Write "Getting Hosting OU Object failed: " & HostingAdsPath
				Response.Write "<BR>"
			End if
		
		' Set Proper Ace Entries
		Set SecurityDescriptor = objHostingOU.Get("ntSecurityDescriptor")
		'DetailError "Unable to Access the SecurityDescriptor or Access is Denied (ResetASPSecurity)"
	
		Set Dacl = SecurityDescriptor.DiscretionaryAcl
		'DetailError "Unable to Access the DiscretionaryAcl or Access is Denied (ResetASPSecurity)"
		
		' Clean out ACE from Previous Web Admin Builds
		DeleteAce dacl, MASTER_GROUP_ALLMULTIORGADMIN
		DeleteAce dacl, MASTER_GROUP_ALLUSERS
		
		' Remove the ability for any user in the Directory to access this
		'	OU or its object
		DeleteAce dacl, "NT AUTHORITY\Authenticated Users"
		
		AddAce dacl, MASTER_GROUP_ALLMULTIORGADMIN, 917801, 0, 2, 0, 0, 0
		If Err.number <> 0 then
			Response.Write "<BR>"
			Response.Write "Unable to Add Security Setting"
			Err.Clear
		Else
			Response.Write "<BR>"
			Response.Write "Added Security Setting Successfully"
		End If
		
		' This object and all child objects, (List Contents, List Objects, Read All Properties)
		AddAce dacl, MASTER_GROUP_ALLUSERS, 148, 0, 0, 0, 0, 0
			
		'*** Give all Hosted Users that ability access to their OU through the Hosting OU.
		'If LIST_OBJECT_MODE_ON Then
			' This object and all child objects, (???)
		'	AddAce dacl, MASTER_GROUP_ALLUSERS, 128, 0, 0, 0, 0, 0
		'Else
			' This object and all child objects, (List Contents, List Objects, Read All Properties)
		'	AddAce dacl, MASTER_GROUP_ALLUSERS, 148, 0, 0, 0, 0, 0
		'End If
	
		'*** Add New Dacl to the Security Descriptor
		SecurityDescriptor.discretionaryAcl = dacl
		objHostingOU.put "ntSecurityDescriptor", SecurityDescriptor
		
		objHostingOU.SetInfo
		
		
End Function
'********************************************************************
'*
'* Function DeleteAce(dacl, TrusteeName)
'* Purpose: Delete an Access Control Entry (ACE) from an Access Control List.
'* Input:   	dacl			Access Control List (Object)
'*				TrusteeName		Name of the Trustee you want to delete
'*										 
'* Output:  None
'*
'********************************************************************
Function DeleteAce(dacl, TrusteeName)
On Error Resume Next
' Bubble Any Error to the Calling Function.
	Dim oACE
	
	' Create a temp ACE Object
	Set oACE = CreateObject("AccessControlEntry")
		' Recurse through the ACL
		For Each oAce in dacl
			'Find the Trustee you are looking to delete.
			if (Trim(lcase(oAce.Trustee)) = Trim(lcase(TrusteeName))) then
				' Delete the ACE from the ACL
				dacl.RemoveAce(oAce)
			End if
		Next
	
	' Kill Objects
	Set oACE	= Nothing
End Function

'********************************************************************
'*
'* Function ReorderACL(objDACL)
'*
'* Purpose: Reorders a DACL properly
'* Input:   	objDACL						Access Control List (Object)
'*				bMakeExplicit				Determinse if whether or not inherited
'*											ACE Settings should be stripped (boolean)
'*				
'* Output:  Object - Reordered DACL
'*
'********************************************************************
Function ReorderACL(objDACL, bMakeExplicit)
	' Dim Objects
	Dim ImpDenyDacl, ImpDenyObjectDacl, InheritedDacl, ImpAllowDacl, ImpAllowObjectDacl
	Dim objSD, newDACL
	
	' Dim Other Variables
	Dim ace
	
	' Set Constants
	Const ADS_ACEFLAG_INHERITED_ACE				= &H10
	Const ADS_ACETYPE_ACCESS_ALLOWED			= &H0
	Const ADS_ACETYPE_ACCESS_DENIED				= &H1
	Const ADS_ACETYPE_ACCESS_ALLOWED_OBJECT		= &H5
	Const ADS_ACETYPE_ACCESS_DENIED_OBJECT		= &H6
	
	' Create the New DACL
	Set objSD = Server.CreateObject("SecurityDescriptor")
	
	' Create the ACL Objects
	Set newDACL					= Server.CreateObject("AccessControlList")
	Set ImpDenyDacl				= Server.CreateObject("AccessControlList")
	Set ImpDenyObjectDacl		= Server.CreateObject("AccessControlList")
	Set InheritedDacl			= Server.CreateObject("AccessControlList")
	Set ImpAllowDacl			= Server.CreateObject("AccessControlList")
	Set ImpAllowObjectDacl		= Server.CreateObject("AccessControlList")
	
	    ' Loop through the Original Dacl.
    For Each ace In objDACL
    If bMakeExplicit Then
         If ((ace.AceFlags And ADS_ACEFLAG_INHERITED_ACE) = ADS_ACEFLAG_INHERITED_ACE) Then
            ace.AceFlags = ace.AceFlags Xor ADS_ACEFLAG_INHERITED_ACE
        End If
   Else
                 ' Don't really care about the order of inherited aces.  Since we are
            ' adding them to the top of a new list, when they are added back
            ' to the Dacl for the object, they will be in the same order as they were
            ' originally.  Just a positive side affect of addin items or a LIFO
            ' (Last In First Out) type list'
           InheritedDacl.AddAce ace
            
    End If
            ' We have an Implicit Ace, lets put it in the proper pool
            Select Case ace.AceType
                Case ADS_ACETYPE_ACCESS_ALLOWED
                    ImpAllowDacl.AddAce ace
                Case ADS_ACETYPE_ACCESS_DENIED
                    ImpDenyDacl.AddAce ace
                Case ADS_ACETYPE_ACCESS_ALLOWED_OBJECT
                    ImpAllowObjectDacl.AddAce ace
                Case ADS_ACETYPE_ACCESS_DENIED_OBJECT
                    ImpDenyObjectDacl.AddAce ace
                Case Else
                    'Bad Ace, but let's just leave it out for now.
            End Select
    
    Next
	'
	' Combine the ACEs in the Proper Order
	'	Implicit Deny
	'	Implicit Deny Object
	'	Implicit Allow
	'	Implicit Allow Object
	'	Inherited ACEs
	'
	
	' Implicit Deny
		For Each ace in ImpDenyDacl
			newDACL.AddAce ace
		Next
		
	' Implicit Deny Object
		For Each ace in ImpDenyObjectDacl
			newDACL.AddAce ace
		Next
		
	' Implicit Allow
		For Each ace in ImpAllowDacl
			newDACL.AddAce ace
		Next
		
	' Implicit Allow Object
		For Each ace in ImpAllowObjectDacl
			newDACL.AddAce ace
		Next
		
	' Inherited ACEs
		For Each ace in InheritedDacl
			newDACL.AddAce ace
		Next
	
	'Set the Appropriate revision level for the DACL
	newDACL.AclRevision = objDACL.AclRevision
	
	' Return Properly Ordered DACL
	Set ReorderACL = newDACL
	
	' Kill Objects
	Set newDACL					= Nothing
	Set InheritedDacl			= Nothing
	Set ImpAllowObjectDacl		= Nothing
	Set ImpAllowDacl			= Nothing
	Set ImpDenyObjectDacl		= Nothing
	Set ImpDenyDacl				= Nothing
	Set objSD					= Nothing
	
End Function


'********************************************************************
'*
'* Function AddAce(dacl, TrusteeName, gAccessMask, gAceType,_
'*				 gAceFlags, gFlags, gObjectType, gInheritedObjectType)
'*
'* Purpose: Adds and ACE to an existing ACL
'* Input:   	dacl						Access Control List (Object)
'*				TrusteeName					Name of Trustee to add (String)
'*				gAccessMask					AccessMask (String)
'*				gAceType					AceType ()
'*				gAceFlags					AceFlags ()
'*				gFlags						Flags ()
'*				gObjectType					ObjectType ()
'*				gInheritedObjectType		InheritedObjectType ()
'*				
'* Output:  None
'*
'********************************************************************
Function AddAce(dacl, TrusteeName, gAccessMask, gAceType, gAceFlags, gFlags, gObjectType, gInheritedObjectType)
' Bubble Error to Calling Function
On Error Resume Next
	Dim Ace1
	' Add New Ace for Apply Policy
	Set Ace1 = CreateObject("AccessControlEntry")
	Ace1.AccessMask = gAccessMask
	Ace1.AceType = gAceType
	Ace1.AceFlags = gAceFlags
	Ace1.Flags = gFlags
	Ace1.Trustee = TrusteeName

		'Check to See if ObjectType needs to be set
		If cStr(gObjectType) <> "0" then
			Ace1.ObjectType = gObjectType
		End If

		'Check to See if InheritedObjectType needs to be set
		If cStr(gInheritedObjectType) <> "0" then
			Ace1.InheritedObjectType = gInheritedObjectType
		End If
	dacl.AddAce Ace1
	
	' Kill Objects
	Set Ace1 = Nothing
End Function

'********************************************************************
'*
'* Function CreateGroup(xOuObj, cGroupName, cGroupDesc, [nestInGroup])
'* Purpose: Creates a Group in an OU
'* Input:   	xOuObj					OU Container to Create Group In. (Object)
'*				cGroupName				Name of Group to Create (String)
'*				cGroupDesc				Group Description (String)
'*				[nestInGroupAdsPath]	Name of Group to Nest In (String)
'*				
'* Output:  None
'*
'********************************************************************
Function CreateGroup(xOuObj, cGroupName, cGroupDesc, nestInGroupAdsPath)
'On Error Resume Next
' Bubble Error to Calling Functin
	Dim cNewGroup
	Dim SecurityDescriptor, Dacl
	' Create the New Group
	Set cNewGroup = xOuObj.Create("group","CN=" & cGroupName)
	
	' Add in nessasary attributes
	cNewGroup.put "SamAccountName", cGroupName
	cNewGroup.put "displayName", cGroupName
	
	' Don't enter blanks if you don't have to.
	If cGroupDesc <> "" or cGroupDesc <> null then
		cNewGroup.put "Description", cGroupDesc
	End IF
		
	' Save the information.  If this is not done, the creation 
	'		process will not be finished.
	cNewGroup.SetInfo
	
	' Check to see if ASP Services is Enabled
	If ASP_SERVICES_ENABLED Then
	
		' Set Proper Ace Entries
		Set SecurityDescriptor = cNewGroup.Get("ntSecurityDescriptor")
		'DetailError "Unable to Access the SecurityDescriptor or Access is Denied (ResetASPSecurity)"
	
		Set Dacl = SecurityDescriptor.DiscretionaryAcl
		'DetailError "Unable to Access the DiscretionaryAcl or Access is Denied (ResetASPSecurity)"
	
		' Remove the ability for any user in the Directory to access this
		'	OU or its object
		DeleteAce dacl, "NT AUTHORITY\Authenticated Users"
	
		'*** Add New Dacl to the Security Descriptor
		SecurityDescriptor.discretionaryAcl = dacl
		cNewGroup.put "ntSecurityDescriptor", SecurityDescriptor
	
		' Save the information. 
		cNewGroup.SetInfo
		
	End If
	
	If NOT ASP_SERVICES_ENABLED AND NOT AD_NATIVE_MODE_ON Then
		'Do not do nesting, because the Web Admin is in Enterpise mode and not in Native Mode
	Else
		' Check to see if this group needs to be nested in another group
		If len(trim(nestInGroupAdsPath)) > 0 then
			  AddToGroup nestInGroupAdsPath, cNewGroup.AdsPath
		End If
	End If
	
	' Write to Log
	WriteLog "CreateGroup",0, "Created: " & cGroupName & Chr(10) & "Parent; " & xOuObj.AdsPath
	
	' Return New Group AdsPath
	CreateGroup = cNewGroup.AdsPath
	
	' Kill Object
	Set cNewGroup = Nothing
End Function

'********************************************************************
'*
'* Function DeleteObject(sObjAdsPath,sObjType)
'* Purpose: Delete an object from the Directory
'* Input:   	sObjAdsPath		Ads Path (String)
'*				sObjType		type of Object (String)
'*				
'* Output:  True/False
'*
'********************************************************************
Function DeleteObject(sObjAdsPath,sObjType)
On Error Resume Next
	Dim sOuName, sAdServer, objName, tempObj,gObjOUAdsPath, output
	
	' Get the Object that you want to delete.
	Set tempObj = GetObject(sObjAdsPath)
		DetailError "Unable to Get Object.  Object may not exist or Access Denied. (DeleteObject::tempObj)"
	
	' Set a Variable for the object name of the object that is going to be deleted
	objName = tempObj.Name
		
	' Get the ADS Path of the Parent Container from the Ads Path
	gObjOUAdsPath = tempObj.Parent
	
	' Destroy Object
	Set tempObj = Nothing
	
	'Get the Object Container of the object that will be deleted.
	Set sAdServer = GetObject(gObjOUAdsPath)
		DetailError "Unable to Get Object.  Object may not exist or Access Denied. (DeleteObject::sAdServer)"
	
	' Delete the object
	output = sAdServer.Delete(sObjType, objName)
		If Err.number <> 0 then
			DeleteObject = False
				' Write to Log
				WriteLog "DeleteObject",1, "Failed deleting: " & sObjType & chr(10) & "Parent: " & sObjAdsPath
		Else
			DeleteObject = True
				' Write to Log
				WriteLog "DeleteObject",0, "Deleted: " & sObjType & chr(10) & "Parent: " & sObjAdsPath
		End If
		
	' Kill Objects
	Set sAdServer = Nothing
		DetailError "Unable to Delete Object.  Object may not exist or Access Denied. (DeleteObject)"
End Function



'********************************************************************
'*
'* Function CreateNewUser(sAdsPath, sOuName, sUsername, sFirstName, _
'*							sLastName, sPassword, sProfilePath, sUserType, _
'*							sService, sAdmin, pwdLastSet)
'*
'* Purpose: Create a new user in the directory
'* Input:   	sAdsPath			Ads Path of the Parent Container (String)
'*				sOuName				User Principal Name Suffix (String)
'*				sUsername			Username  (String)
'*				sFirstName			First Name (String)
'*				sLastName			Last Name (String)
'*				sPassword			Password  (String)
'*				sProfilePath		Profile Path (String)
'*				sUserType			User Type; Normal (0) /Advanced (1)
'*				sService			Service Type(String) - For Future Use.
'*				sAdmin				Admin Setting; No (Default;0)/ Yes (1)
'*				pwdLastSet			Expiration Date; none (Default)/ (Date)
'*				
'* Output:  New User's Adspath (String)
'*
'********************************************************************
Function CreateNewUser(sAdsPath, sOuName, sUsername, sFirstName, sLastName, sPassword, sProfilePath, sUserType, sService, sAdmin, pwdLastSet)
On Error Resume Next
	Dim rootDSE, sRootOU, sAdServer, cNewUser, sUser, sUserAdsPath, newSamAccountName
	Dim SecurityDescriptor, Dacl
	Dim tempUserAdspath
	
	' Get the Container for the New User
	sRootOU = GetRootOU(sAdsPath)
	DetailError "Unable to Get the Root OU Object.  The Object does not exist or you don't have access to that object (CreateNewUser)"
	
	'Set Other Variables
	NORMAL_USER_GROUP 					= constNORMAL_USER_GROUP & sRootOU
	ADVANCED_USER_GROUP 				= constADVANCED_USER_GROUP & sRootOU
	ALL_USERS_GROUP						= constALL_USERS_GROUP & sRootOU 
	ADMINS_GROUP						= constADMINS_GROUP & sRootOU
	
	' Check to see if the sAdmin variable was passed
	If sAdmin = "" or IsNull(sAdmin) then
		' If Not, then the user will not be and Admin
		sAdmin= 0
	End If
		
	'Begin getting Objects from the Active Directory
	Set sAdServer = GetObject(sAdsPath)
	
	' Create the New User
	Set cNewUser = sAdServer.Create("user", "cn=" & sUsername)
		DetailError "Unable to Create User.  Unknown Reason or Access Denied. (CreateNewUser)"
		'WriteLog "CreateNewUser",0, "Created:" & sUsername & chr(10) & "Now Setting Attributes"
	
	' Check to See if the Web Admin Tool is set for use in a Service Provider Environement
	If ASP_SERVICES_ENABLED Then
		' Set Attributes
		' The UPN must be unique
		If UpnExist(sUserName & "@" & sRootOU) Then
				Err.description = "User Already Exists"
			Exit Function
		End If
		cNewUser.put "userPrincipalName", cStr(sUserName & "@" & sRootOU)
		
		
		' The SAM name must not exeed 20 Charactors.  User will never use this, but we still 
		'	want it to be descriptive and short.  The OU name is put in front, but must not 
		'	exceed 8 charactors.  The GetUniqueSamName will return bace a unique username to 
		'	use.
		newSamAccountName = GetUniqueSamName(Replace(Mid(sRootOU,1,10),".","") & "_" & sUserName)
		cNewUser.put "samAccountName", newSamAccountName
	Else
		' Set Attributes
		cNewUser.put "userPrincipalName", cStr(sUserName & "@" & DomainDNS2DomainDN(GetDomain()))
		cNewUser.put "samAccountName", cStr(sUserName)
	End If
	
	cNewUser.put "givenName", cStr(sFirstName)
	cNewUser.put "sn", cStr(sLastName)
	cNewUser.put "displayName", cStr(sFirstName) & " " & cStr(sLastName)
	
	' Check to see if Profile should be set (Look in Global.asa for more Info or use CurrentConfig.asp so set.)
	If SET_USER_PROFILE AND Trim(sProfilePath <> "") then
		' Check to see if Profile needs to be set
		If trim(lcase(sProfilePath)) = "no_prof" then
			sProfilePath = " "
		Else
			' check to see if the slash was entered as part of the argument passed
		    If instrRev(mid(sProfilePath,Len(sProfilePath)), "\") then
				sProfilePath = sProfilePath & sUserName & "@" & sRootOU
			else 
				sProfilePath = sProfilePath & "\" & sUserName & "@" & sRootOU
			end If
		End If
		
		' Set the Profile Location Path for the User
		cNewUser.put "profilePath", cStr(sProfilePath)
	End If
	
	' Do the Initaial Save, but this is not the end!
	'  To finish the process, you must set the password and Make Active.
	cNewUser.SetInfo
		If Err.number <> 0 then
			' Bubble Error UP.
			DetailError "Error: Could not Save Information.  You may not have rights to perform this function or that username is already in use  (CreateNewUser)"
			Exit Function
		End If
	
	' Set the User's Initial Password
	cNewUser.SetPassword sPassword
		If Err.number <> 0 then
			tempUserAdspath = cNewUser.Adspath
			Set cNewUser = Nothing
			DeleteObject tempUserAdspath, "user"
			DetailError "Could not Set Password.  You may not have rights to perform this function. (CreateNewUser)"
		End If
		
	' Make the Account Active
	cNewUser.AccountDisabled = False
	
	' Set the password to be expired.
		If pwdLastSet = "on" then
			cNewUser.put "pwdLastSet", CLng(0)
		End If
		
	'Initial Creation of the User is Complete!
	cNewUser.SetInfo
		If Err.number <> 0 then
			tempUserAdspath = cNewUser.Adspath
			Set cNewUser = Nothing
			DeleteObject tempUserAdspath, "user"
			DetailError "Could not Save Information.  You may not have rights to perform this function. (CreateNewUser)"
		End If
	
	' Set UserAdsPath for use with Group Additions
	sUserAdsPath = cNewUser.AdsPath
	
	' Check to See if the Web Admin Tool is set for use in a Service Provider Environement
	If ASP_SERVICES_ENABLED Then
	
		' Set Proper Ace Entries
		Set SecurityDescriptor = cNewUser.Get("ntSecurityDescriptor")
		'DetailError "Unable to Access the SecurityDescriptor or Access is Denied (ResetASPSecurity)"
	
		Set Dacl = SecurityDescriptor.DiscretionaryAcl
		'DetailError "Unable to Access the DiscretionaryAcl or Access is Denied (ResetASPSecurity)"
	
		' Remove the ability for any user in the Directory to access this
		'	OU or its object
		DeleteAce dacl, "NT AUTHORITY\Authenticated Users"
	
		'*** Add New Dacl to the Security Descriptor
		SecurityDescriptor.discretionaryAcl = dacl
		cNewUser.put "ntSecurityDescriptor", SecurityDescriptor
	
		'Save with new Security Settings
		cNewUser.SetInfo
			If Err.number <> 0 then
				tempUserAdspath = cNewUser.Adspath
				Set cNewUser = Nothing
				DeleteObject tempUserAdspath, "user"
				DetailError "Could not save Security Settings. (CreateNewUser)"
			End If
	
		'Add User to All User Group for their OU
		AddToGroup "LDAP://CN=" & ALL_USERS_GROUP & ",OU=" & sRootOU & ",OU=" & HOSTING_OU & "," & GetDomain, sUserAdsPath
		DetailError "Unable to Unable to Map to Group.  Unknown Reason or Access Denied. (CreateNewUser)"
	
	'Set User Type
		Select Case sUserType
			Case 1
				AddToGroup "LDAP://CN=" & ADVANCED_USER_GROUP & ",OU=" & sRootOU & ",OU=" & HOSTING_OU & "," & GetDomain, sUserAdsPath
				DetailError "Unable to map to Group. (CreateNewUser)"
			Case Else
				AddToGroup "LDAP://CN=" & NORMAL_USER_GROUP & ",OU=" & sRootOU & ",OU=" & HOSTING_OU & "," & GetDomain, sUserAdsPath
				DetailError "Unable to map to Group. (CreateNewUser)"
		End Select
	End If
	
	' Set Admin
		If sAdmin = 1 then
			AddToGroup "LDAP://CN=" & ADMINS_GROUP & ",OU=" & sRootOU & ",OU=" & HOSTING_OU & "," & GetDomain, sUserAdsPath
				DetailError "Unable to map to Group. (CreateNewUser)"
		End If
	
	'Write Success to Log
	WriteLog "CreateNewUser",0, "Username: " & sUsername & chr(10) & "Created in:" & sAdsPath
	
	'Return the New Users Adspath
	CreateNewUser = cNewUser.AdsPath
	
	' Kill Objects
	Set sAdServer		= Nothing
	Set cNewUser		= Nothing
End Function

'********************************************************************
'*
'* Function UpnExist(varUPN)
'* Purpose: Pass in a UPN and see if it exists
'* Input:   	varUPN		UPN of User  (String)
'*										
'* Output:  True/False
'*
'********************************************************************
Function UpnExist(varUPN)
	Dim X, MyUser
	Dim con, rs, adsQuery, UserRS
	
	' Set the ADO Objects for Use in the Search
	Set Con = Server.CreateObject("ADODB.Connection")
	Set rs = Server.CreateObject("ADODB.Recordset")
	
	' Set ADO Provider Information    
	con.Provider = "ADsDSOObject"
	con.Open "Active Directory Provider"
	
	adsQuery = "<LDAP://" & GetDomain & ">;(&(userPrincipalName=" & varUPN & ")(objectClass=User));ADsPath,cn,userPrincipalName,memberOf,givenName,sn,mail;subtree"
	
	'Execute the Query
	Set rs = con.Execute(adsQuery)
		DetailError "_Error: Could not execute ADO Query with ADSI Provider. (UpnExist)"
		
	'
	If Rs.EOF Then
		UpnExist = False
	Else
		UpnExist = True
	End If
	
	' Kill Objects
	Set Con			= Nothing
	Set rootDSE		= Nothing
	
End Function

'********************************************************************
'*
'* Function GetUniqueSamName(varUsername)
'* Purpose: Pass in a Name and it will return a Unique Username
'* Input:   	varUsername		Username of User  (String)
'*										
'* Output:  Unique Username (String)
'*
'********************************************************************
Function GetUniqueSamName(varUsername)
	Dim Counter, gotUniqueFlag, tempNewUsername,UserRS
	
	' Check to see if the Username passed is greater than 20 charactors.  If so, 
	'	then cut the user down to 17 charactors.  This give you space to add numeric 
	'	charactors at the end of the username to make it unique (if needed).
	If Len(varUsername) >= 20 then varUsername = mid(varUsername,1,17)
		
	gotUniqueFlag = False
	Do while not gotUniqueFlag
		tempNewUsername = varUsername & Counter
		Set UserRS = SearchForUserBySAM(tempNewUsername,1)
			If UserRS.EOF Then
				gotUniqueFlag = True
			Else
				Counter = Counter + 1
			End If
		' Kill the object after each search.
		Set UserRS  = Nothing
	Loop
	GetUniqueSamName = tempNewUsername
	
End Function

'********************************************************************
'*
'* Function AddToGroup(targetGroupAdsPath, ObjectToBeAdded)
'* Purpose: Adds an object to a Group
'* Input:   	targetGroupAdsPath	Target Groups AdsPath  (String)
'*				ObjectToBeAdded		AdsPath of Object that wants to be added
'*										 to targetMasterGroup (String)
'* Output:  None
'*
'********************************************************************
Function AddToGroup(targetGroupAdsPath, ObjectToBeAdded)
On Error Resume Next
' Bubble up error to Calling Function
	Dim targetObj 
		
	' Get the Target Group
	Set targetObj = GetObject(targetGroupAdsPath)
	
	' Add User to Group.
	targetObj.Add ObjectToBeAdded 
	
	' If User is Already in the Group, clear the error and move on.
	If cstr(Err.number) = "-2147019886" then
		Err.Clear 
	End IF

	' Write to Log
	WriteLog "AddToGroup" ,0, "Added: " & ObjectToBeAdded & chr(10) & "Group: " & targetGroupAdsPath
	
	' Kill Objects
	Set targetObj		= Nothing
End Function

'********************************************************************
'*
'* Function RemoveFromGroup(targetGroupAdsPath, UserToBeRemoved)
'* Purpose: Remove Items from Group.
'* Input:   	targetGroupAdsPath		Group AdsPath (String)
'*				UserToBeRemoved			User that needs to be removed (String)
'*										 
'* Output:  None
'*
'********************************************************************
Function RemoveFromGroup(targetGroupAdsPath, UserToBeRemoved)
On Error Resume Next	
	Dim targetObj 
	
	' Get the Group Object
	Set targetObj = GetObject(targetGroupAdsPath)
	
	'Remove the User from the group
	targetObj.Remove UserToBeRemoved
	
	' If User is not in the Group, clear the error and move on.
	If Err.number = "-2147016651" then
		Err.Clear 
	End IF

	' Write to Log
	WriteLog "RemoveFromGroup" ,0, "Removed: " & UserToBeRemoved & chr(10) & "Group: " & targetGroupAdsPath
		
	' Kill Object
	Set targetObj		= Nothing
	
End Function

'********************************************************************
'*
'* Function ResetPassword(g_AuthUser, g_NewPassword)
'* Purpose: Reset a Users Password
'* Input:   	g_AuthUser			User Ads Path (String)
'*				g_NewPassword		New Password (String)
'*										
'* Output:  None
'*
'********************************************************************
Function ResetPassword(g_AuthUser, g_NewPassword)
On Error Resume Next
	' Get the User Object
	Set UserObj = GetObject(g_AuthUser)
		IF Err.number <> 0 then
			ResetPassword = "_Error: Could not Get UserObject"
			Exit Function
		End If
		
	' Set the Password.  No Need to SetInfo when Setting Passwords.
	UserObj.SetPassword cstr(g_NewPassword)
		IF Err.number <> 0 then
			ResetPassword = "_Error: Could not Save Information"
			
			' Write to Log
			WriteLog "ResetPassword" ,1, "User: " & g_AuthUser & chr(10) & "Parent: " & UserObj.Parent
			
			Exit Function
		Else
			ResetPassword = "Password Change Successfully!"
			' Write to Log
			WriteLog "ResetPassword" ,0, "User: " & g_AuthUser & chr(10) & "Parent: " & UserObj.Parent
			
		End If
		
	' Kill Objects
	Set UserObj		= Nothing
	
End Function

'********************************************************************
'*
'* Function UpdatePassword(oUser, g_OldPassword, g_NewPassword)
'* Purpose: Update a Users Password
'* Input:   	oUser				AdsPath Of User (Object)
'*				g_OldPassword		Old Password (String)
'*				g_NewPassword		New Password (String)
'*									
'* Output:  None
'*
'********************************************************************
Function UpdatePassword(oUser, g_OldPassword, g_NewPassword)
On Error Resume Next
	' Change the Password
	oUser.ChangePassword g_OldPassword, g_NewPassword
		IF Err.number <> 0 then
			UpdatePassword = "Failed"
			' Write to Log
			WriteLog "UpdatePassword",1, g_AuthUser
			Exit Function
		Else
			' Write to Log
			WriteLog "UpdatePassword",0, g_AuthUser
		End If
End Function

'********************************************************************
'*
'* Function UpdateUserAttrib(objUserTemp, Attrib_Name, Attrib_Value)
'* Purpose: Add an Attribute to an Object.
'* Input:   	objUserTemp		Object to be updated (Object)
'*				Attrib_Name		Name of Attribute to Add (String)
'*				Attrib_Value	Value for Attribute (String)
'*
'* Output:  None
'*
'********************************************************************
Function UpdateUserAttrib(objUserTemp, Attrib_Name, Attrib_Value)
'On Error Resume Next
' Bubble Error to Calling Function
	Dim totalLength
	Dim strLogEvent
	'Check to see if there is a Value to set.
	If Attrib_Value = "" or isnull(Attrib_Value) then
		' If Not, Send a Clear message for this attribute to the directory.
		'	Just in Case the Value is NOW set to Nothing!!
		objUserTemp.PutEx 1, Attrib_Name, vbNullString
	Else
		' Allow for the use of the * wildcard.  This will allow you to
		'		do an append to an attribute behind the entered Attrib_Value.
		totalLength		= len(Attrib_Value)
		If instr(1, Attrib_Value, "*") = 1 then
			Attrib_Value = objUserTemp.Get(Attrib_Name) & Mid(Attrib_Value,2)
		End If
		
		' Allow for the use of the -* wildcard.  This will allow you to
		'		do a delete of a string anywhere in the field.
		totalLength		= len(Attrib_Value)
		If instr(1, Attrib_Value, "-*") = 1 then
			' Check to see if this field is not yet set.
			If objUserTemp.Get(Attrib_Name) <> "" or not isNull(objUserTemp.Get(Attrib_Name)) then
				Attrib_Value = Replace(lcase(objUserTemp.Get(Attrib_Name)),lcase(Mid(Attrib_Value,3)),"")
			End If
		End If
		
		' Do a Direct Update
		objUserTemp.put Attrib_Name, Attrib_Value
		UpdateUserAttrib = 0
	End If
	
	If Err.number <> 0 Then
		' Check to see if Attribute settings are supposed to be logged.
			If LOG_ALLOW_ATTRIBUTE_UPDATES Then
				' Write to Log
				WriteLog "UpdateAttrib",1, "Name=" & Attrib_Name & chr(10) & "Value=" & Attrib_Value
			End If		
	Else
		' Check to see if Attribute settings are supposed to be logged.
			If LOG_ALLOW_ATTRIBUTE_UPDATES Then
				' Write to Log
				WriteLog "UpdateAttrib",0, "Name=" & Attrib_Name & chr(10) & "Value=" & Attrib_Value
			End If		
	End If
	
End Function


'********************************************************************
'*
'* Function GetOrgs()
'* Purpose: Get Root OUs
'* Input:   None
'*				
'* Output:  None
'*
'********************************************************************
Function GetOrgs()
On Error Resume Next
	
	' Check to see if ASP Services is Enabled
	If ASP_SERVICES_ENABLED Then
		sAdsPath = "LDAP://OU=" & HOSTING_OU & "," & GetDomain()
	Else
		sAdsPath = "LDAP://" & GetDomain()
	End If
	
	Set ldap = GetObject(sAdsPath)
		DetailError("Unable to Get OU.  You may not have the permissions nessasary to perform this function.  (GetOrgs)")
	
	Set GetOrgs = ldap
		DetailError("Unable to pass back OU Object.  variable Ldap may not be an Object.  (GetOrgs)")
	
	' Kill Objects
	Set rootDSE		= Nothing
	Set ldap		= Nothing
End Function

'********************************************************************
'*
'* Function GetOrgInfo(g_AuthUser)
'* Purpose: Get Root OUs
'* Input:   None
'*				
'* Output:  None
'*
'********************************************************************
Function GetOrgInfo(g_AuthUser)
On Error Resume Next
	Dim objectPrefix
	UserOuName = ParseOU(g_AuthUser)
		If lcase(UserOuName) = "users" then
			objectPrefix = "CN="
		Else
			objectPrefix = "OU="
		End If
		
	sAdsPath = "LDAP://" & objectPrefix & UserOuName & "," & GetDomain
	Set GetOrgInfo = GetObject(sAdsPath)
		DetailError "You Do Not have access to view this Object or the obejct does not exist. (GetOrgInfo)"
End Function

'********************************************************************
'*
'* Function GetAuthUserInfo(strAuthUser)
'* Purpose: Pass in the a AuthUser String From Request.ServerVariables and 
'*				Get back the Users ADS Object
'*
'* Input:   	strAuthUser			User Sam Account Name (String)
'*				
'* Output:  Object - Users Object
'*
'********************************************************************
Function GetAuthUserInfo(strAuthUser)
On Error Resume Next
	Dim objGC, objGCchild, objRootGC, objRootGCItem, UserAdsPath, tempUserAdsPath
	
	' Search for the User by their UPN/SAM Name
	Set UserAdsPath = SearchForUserByUPN(strAuthUser,0)
		DetailError "Could not find this object in the directory. (GetAuthUserInfo)"
	
	' Build the AdsPath to the User.  The SearchForUserUPN function MAY return the users path from
	'	the Global Catalog.  If so, Switch the Protocol with and LDAP.
	If Instr(1,lcase(UserAdsPath.Fields("adspath")),"gc://") Then
		tempUserAdsPath = Replace(lcase(UserAdsPath.Fields("adspath")),"gc://","LDAP://")
	Else 
		tempUserAdsPath = UserAdsPath.Fields("adspath")
	End If
	
	' Get/Return the Users Object Via Their Ads Path
	Set GetAuthUserInfo = GetObject(tempUserAdsPath)	
		DetailError "You Do Not have access to view this Object, the object does not exist, or the user object does not have a user principal name. This also applies to the user accout you logged on as.  You need a UPN too. (GetAuthUserInfo)"
	
	' Kill Objects
	Set UserAdsPath = Nothing
End Function
	
'********************************************************************
'*
'* Function GetAdsObj(g_AdsPath)
'* Purpose: Get an ADS Object (User, Group, OU, etc.) via an Ads Path
'* Input:   	g_AdsPath			Object's AdsPath (String)
'*				
'* Output:  None
'*
'********************************************************************
Function GetAdsObj(g_AdsPath)
On Error Resume Next
	' Get the Object Via Ads Path
	Set GetAdsObj = GetObject(g_AdsPath)	
		DetailError "You Do Not have access to view this Object or the object does not exist. (GetAdsObj)"
End Function

'********************************************************************
'*
'* Function SearchForUserByUPN(varUserUPN,intSearchDepth)
'* Purpose: Adds a Group to a Group
'* Input:   	varUserUPN			Users UPN to Search For (String)
'*				intSearchDepth		Search Tree on only in a single Container
'*										(Not Yet Implemented)
'*	
'* Output:  None
'*
'********************************************************************
Function SearchForUserByUPN(varUserUPN,intSearchDepth)
On Error Resume Next
	Dim X, MyUser
	Dim con, rs, adsQuery
	
	' Set the ADO Objects for Use in the Search
	Set Con = Server.CreateObject("ADODB.Connection")
	Set rs = Server.CreateObject("ADODB.Recordset")
	
	' Set ADO Provider Information    
	con.Provider = "ADsDSOObject"
	con.Open "Active Directory Provider"
	
	' Response.Write varUserUPN
	adsQuery = "<LDAP://" & GetDomain & ">;(&(userPrincipalName=" & varUserUPN	 & ")(objectClass=User));ADsPath,cn,userPrincipalName,memberOf,givenName,sn,mail;subtree"
	
	'Execute the Query
	Set rs = con.Execute(adsQuery)
		DetailError "_Error: Could not execute ADO Query with ADSI Provider. (SearchForUserByUPN)"
	
	' If the query fails with UPN, try for the SAM Account Names.
	If RS.EOF then
		' Response.Write varUserUPN
		adsQuery = "<LDAP://" & GetDomain & ">;(&(samAccountName=" & varUserUPN	 & ")(objectClass=User));ADsPath,cn,userPrincipalName,memberOf,givenName,sn,mail;subtree"
	
		'Execute the Query
		Set rs = con.Execute(adsQuery)
			DetailError "_Error: Could not execute ADO Query with ADSI Provider [2]. (SearchForUserByUPN)"

	End IF
	
	' If the query fails with UPN and SAM, try one last time, but query the Global Catalog Instead
	If RS.EOF then
	
		Set rootDSE = GetObject("LDAP://RootDSE")
		' Response.Write varUserUPN
		adsQuery = "<GC://" & rootDSE.Get("defaultNamingContext") & ">;(&(userPrincipalName=" & varUserUPN	 & ")(objectClass=User));ADsPath,cn,userPrincipalName,memberOf,givenName,sn,mail;subtree"
		'Response.Write adsQuery
		'Response.End 
		
		'Execute the Query
		Set rs = con.Execute(adsQuery)
			DetailError "_Error: Could not execute ADO Query with ADSI Provider [3]. (SearchForUserByUPN)"
	
	End IF
	
	' If the query fails with UPN and SAM, try one last time, but query the Global Catalog Instead
	If RS.EOF then
	
		Set rootDSE = GetObject("LDAP://RootDSE")
		' Response.Write varUserUPN
		adsQuery = "<GC://" & rootDSE.Get("defaultNamingContext") & ">;(&(samAccountName=" & varUserUPN	 & ")(objectClass=User));ADsPath,cn,userPrincipalName,memberOf,givenName,sn,mail;subtree"
		'Response.Write adsQuery
		'Response.End 
		
		'Execute the Query
		Set rs = con.Execute(adsQuery)
			DetailError "_Error: Could not execute ADO Query with ADSI Provider [4]. (SearchForUserByUPN)"
	
	End IF
	
	' Return the Record Set
	Set SearchForUserByUPN = rs
	
	' Kill Objects
	Set Con			= Nothing
	Set rootDSE		= Nothing
End Function

'********************************************************************
'*
'* Function SearchForUserBySAM(varUserSAM,intSearchDepth)
'* Purpose: Adds a Group to a Group
'* Input:   	varUserSAM			Users SAM to Search For (String)
'*				intSearchDepth		Search Tree on only in a single Container
'*										(Not Yet Implemented)
'*	
'* Output:  None
'*
'********************************************************************
Function SearchForUserBySAM(varUserSAM,intSearchDepth)
On Error Resume Next
	Dim X, MyUser
	Dim con, rs, adsQuery
	
	' Set the ADO Objects for Use in the Search
	Set Con = Server.CreateObject("ADODB.Connection")
	Set rs = Server.CreateObject("ADODB.Recordset")
	'Set rootDSE = GetObject("LDAP://RootDSE")
	
	' Set ADO Provider Information    
	con.Provider = "ADsDSOObject"
	con.Open "Active Directory Provider"
	
	' Response.Write varUserSAM
	adsQuery = "<LDAP://" & GetDomain & ">;(&(samAccountName=" & varUserSAM & ")(objectClass=User));ADsPath,cn,userPrincipalName,memberOf,givenName,sn,mail;subtree"
	
	'Execute the Query
	Set rs = con.Execute(adsQuery)
		DetailError "_Error: Could not execute ADO Query with ADSI Provider. (SearchForUserBySAM)"
	
	' Return the Record Set
	Set SearchForUserBySAM = rs
	
	' Kill Objects
	Set Con			= Nothing
	Set rootDSE		= Nothing
End Function

'********************************************************************
'*
'* Function SearchForObjects(SearchArrayItems, ReturnItemsArray, varSearchScope, intSearchDepth)
'* Purpose: Do an Ado Search in the Directory
'* Input:   	SearchArrayItems		Items & Values to Search For (Array)
'*				ReturnItemsArray		Items to Return (Array)
'*				varSearchScope			Scope; SubTree (0) / One-Level (1)
'*				intSearchDepth			(Not Yet Implemented)
'* Output:  None
'*
'********************************************************************
Function SearchForObjects(SearchArrayItems, ReturnItemsArray, varSearchScope, intSearchDepth)
'On Error Resume Next
	Dim X, MyUser
	Dim con, rs, adsQuery
	Dim SearchFor, SearchItem, SearchDepth
	Dim ReturnItems, CompleteReturnItems

	Set Con = Server.CreateObject("ADODB.Connection")
	DetailError "Could not Create ADODB.Connection Object (SearchForObjects)"
	
	Set rs = Server.CreateObject("ADODB.Recordset")
	DetailError "Could not Create ADODB.Recordset Object (SearchForObjects)"
	    
	con.Provider = "ADsDSOObject"
	con.Open "Active Directory Provider"
	
	For Each SearchItem in SearchArrayItems
		If Trim(SearchItem) <> "" then
			SearchFor = SearchFor & "(" & SearchItem & ")"
		End If
	Next
	
	' Build the Return Result Attributes for the Query
	For Each ReturnItems in ReturnItemsArray
		If trim(ReturnItems) <> "" then
			CompleteReturnItems = CompleteReturnItems & ReturnItems & ","
		End If
	Next
	' Clean out the Last Comma from CompleteReturnItems
	CompleteReturnItems = Mid(CompleteReturnItems,1,Len(CompleteReturnItems)-1)
	intSearchDepth = 0
	' Set Search Depth
	Select Case intSearchDepth
		Case 0
			SearchDepth = "Subtree"
		Case 1
			SearchDepth = "One-Level"
	End Select
	
	' Set SearchScope
	
		' Clean the Search Scope.  These are some basic bad Scopes that may be passed.
		If lcase(Replace(lcase(varSearchScope),"ou=ldap://","")) = lcase(GetDomain()) Then varSearchScope = ""
		If lcase(Replace(lcase(varSearchScope),"ou=ldap://","")) = lcase(GetDomain()) Then varSearchScope = ""
		If lcase(varSearchScope) = "ou=ap:/" Then varSearchScope = ""
	
	If varSearchScope = "" Then
		If ASP_SERVICES_ENABLED And Not IsMultiOrgAdmin(curUserObj.memberOf) Then
			' For ASP Services that are not Multi Org Admins or higher
			varSearchScope = "OU=" & HOSTING_OU & "," & GetDomain
		Else
			' For Mulit Org Admins and Higher AND NON ASP Users
			varSearchScope = GetDomain
		end If
	Else
		If ASP_SERVICES_ENABLED And Not IsMultiOrgAdmin(curUserObj.memberOf) Then
			varSearchScope = varSearchScope & ",OU=" & HOSTING_OU & "," & GetDomain
		Else
			If Not ASP_SERVICES_ENABLED Then
				' For NON ASP Services
				varSearchScope = varSearchScope & "," & GetDomain
			Else
				' For ASP Services
				If instr(1,lcase(varSearchScope), lcase(GetDomain)) > 0 Then
					If instr(1, lcase(varSearchScope), "ou=dc=") then
						varSearchScope = Replace(lcase(varSearchScope), "ou=dc=", "DC=")
					Else
						varSearchScope = varSearchScope
					End If
				Else
					varSearchScope = varSearchScope & ",OU=" & HOSTING_OU & ","  & GetDomain
				End if
			End If
		end If
	End If
	
	' For Testing Use Only.
	'adsQuery = "LDAP://" & varSearchScope & ">;(&" & SearchFor & ");" & CompleteReturnItems & ";" & SearchDepth
	'Response.Write adsQuery & "<BR><BR>"
	'Response.End 
	
	' Build the Entire Search String	
	adsQuery = "<LDAP://" & varSearchScope & ">;(&" & SearchFor & ");" & CompleteReturnItems & ";" & SearchDepth
	
	
	' Execute the Query	
	Set rs = con.Execute(adsQuery)
		DetailError "_Error: Could not execute ADO Query with ADSI Provider. (SearchForObjects)"
	
	' Return the Search Results
	Set SearchForObjects = rs
	
	' Kill Objects
	Set Con			= Nothing
	Set RootDse		= Nothing
	Set rs			= Nothing
End Function

'********************************************************************
'*
'* Function SearchGCForObjects(SearchArrayItems, ReturnItemsArray, varSearchScope, intSearchDepth)
'* Purpose: Does same as SearchGCForObjects, but searchs the GC instead 
'*				of LDAP and does not restrict for ASPHosting or not.
'*
'* Input:   	SearchArrayItems		Items & Values to Search For (Array)
'*				ReturnItemsArray		Items to Return (Array)
'*				varSearchScope			Scope; SubTree (0) / One-Level (1)
'*				intSearchDepth			(Not Yet Implemented)
'* Output:  None
'*
'********************************************************************
Function SearchGCForObjects(SearchArrayItems, ReturnItemsArray, varSearchScope, intSearchDepth)
On Error Resume Next
	Dim X, MyUser
	Dim con, rs, adsQuery
	Dim SearchFor, SearchItem, SearchDepth
	Dim ReturnItems, CompleteReturnItems

	Set Con = Server.CreateObject("ADODB.Connection")
	DetailError "Could not Create ADODB.Connection Object (SearchForObjects)"
	
	Set rs = Server.CreateObject("ADODB.Recordset")
	DetailError "Could not Create ADODB.Recordset Object (SearchForObjects)"
	    
	con.Provider = "ADsDSOObject"
	con.Open "Active Directory Provider"
	
	For Each SearchItem in SearchArrayItems
		If Trim(SearchItem) <> "" then
			SearchFor = SearchFor & "(" & SearchItem & ")"
		End If
	Next
	
	' Build the Return Result Attributes for the Query
	For Each ReturnItems in ReturnItemsArray
		If trim(ReturnItems) <> "" then
			CompleteReturnItems = CompleteReturnItems & ReturnItems & ","
		End If
	Next
	' Clean out the Last Comma from CompleteReturnItems
	CompleteReturnItems = Mid(CompleteReturnItems,1,Len(CompleteReturnItems)-1)
	
	' Set Search Depth
	Select Case intSearchDepth
		Case 0
			SearchDepth = "Subtree"
		Case 1
			SearchDepth = "One-Level"
	End Select
	
	' Set SearchScope
	If varSearchScope = "" Then
		varSearchScope = GetDomain
	Else
		varSearchScope = varSearchScope & "," & GetDomain
	End If
	
	' Bind to the rootDSE
	Set rootDSE = GetObject("LDAP://RootDSE")
	
	' For Testing Use Only.
	'adsQuery = "GC://" & rootDSE.Get("defaultNamingContext") & ">;(&" & SearchFor & ");" & CompleteReturnItems & ";" & SearchDepth
	'Response.Write adsQuery & "<BR><BR>"
	'Response.End 
	
	' Build the Entire Search String	
	adsQuery = "<GC://" & rootDSE.Get("defaultNamingContext") & ">;(&" & SearchFor & ");" & CompleteReturnItems & ";" & SearchDepth
	
	
	' Execute the Query	
	Set rs = con.Execute(adsQuery)
		DetailError "_Error: Could not execute ADO Query with ADSI Provider. (SearchForObjects)"
	
	' Return the Search Results
	Set SearchGCForObjects = rs
	
	' Kill Objects
	Set Con			= Nothing
	Set RootDse		= Nothing
	Set rs			= Nothing
End Function

'********************************************************************
'*
'* Function GetDomain()
'* Purpose: Returns the RootDSE for a given domain.  You can specify a
'*				domain to use by modifing information in lib/config.asp
'* Input:   None
'*				
'* Output:  None
'*
'********************************************************************
Function GetDomain()
	Dim tempDomain
	
	If NOT ASP_SERVICES_ENABLED And Application("WebAdmin_ALLOW_USER_CHOOSE_DOMAIN") And (Session("WebAdmin_USER_CHOOSE_DOMAIN") <> "") Then
		GetDomain = Session("WebAdmin_USER_CHOOSE_DOMAIN")
	Else
		' If the USE_SPECIFIC_DOMAIN has not been set, then get the rootDSE
		'	from the web server that is server the ASP Pages for Web Admin.
		If USE_SPECIFIC_DOMAIN = "" THEN
			If prefdomain <> "" then
				GetDomain = prefdomain
			Else
				' Bind to the rootDSE
				Set rootDSE = GetObject("LDAP://RootDSE")
				DetailError "Unable to Access the RootDSE of the AD or Access is Denied (GetDomain)"

				' Pass the value to a temp object.  This way there is little to 
				'	no dependancy on the object itself. 
				tempDomain = rootDSE.Get("defaultNamingContext")
			
				' Return the domain entry
				GetDomain = tempDomain
			End If
		Else
			' Since there is a specific entry for the domain, just pass that 
			'	back.  There is no validation for the domain entry!
			GetDomain = USE_SPECIFIC_DOMAIN
		End If
	End If
End Function

'********************************************************************
'*
'* Function GetDomainList()
'* Purpose: Returns the Domain list for a specific domain
'*
'* Input:   None
'*						
'* Output:  ADODB Recordset
'*
'********************************************************************
Function GetDomainList()
	Dim objdse
	dim objRS
	dim objADOCom
	dim objADOconn
	dim strADOQueryString
	dim path
	dim domain
	dim s
	Dim rootDSE
	
	' Bind to the rootDSE
	Set rootDSE = GetObject("LDAP://RootDSE")
	'DetailError "Unable to Access the RootDSE of the AD or Access is Denied (GetDomain)"

	' Pass the value to a temp object.  This way there is little to 
	'	no dependancy on the object itself. 
	path = "GC://" & rootDSE.Get("defaultNamingContext")
	'path = "LDAP://" & GetDomain()
	
	Set objADOconn = Server.CreateObject("ADODB.Connection")
	Set objADOCom = Server.CreateObject("ADODB.Command")
	Set objRS = Server.CreateObject("ADODB.Recordset")
	
	objADOconn.Provider ="ADsDSOObject"
	objADOconn.Open "Active Directory Provider"
	
	set objADOCom.ActiveConnection = objADOconn
	objADOCom.Properties("Sort On") = "trustPartner"
	
	strADOQueryString="<" & Path & ">;(objectCategory=trustedDomain);adspath,cn,trustPartner,flatName,trusttype,trustdirection;one-level"
	'Response.Write strADOQueryString
	'Response.End 
	
	objADOCom.CommandText = strADOQueryString
	Set objRS = objADOCom.Execute
	
	' Return Object
	Set GetDomainList = objRS
	
	' Destroy Objects
	Set objADOconn = Nothing
	Set objADOCom = Nothing
	Set objRS = Nothing
	
End Function

'********************************************************************
'*
'* Function FindSchemaAttribByldapDisplayName(strLdapDisplayName)
'* Purpose: Returns athe schema object of the requested ldapDisplayName
'*
'* Input:   strLdapDisplayName			ldap display name of object
'*						
'* Output:  Object
'*
'********************************************************************
Function FindSchemaAttribByldapDisplayName(strLdapDisplayName)
	Dim objdse
	dim objRS
	dim objADOCom
	dim objADOconn
	dim strADOQueryString
	dim path
	dim domain
	dim tempAttribAdspath
		
	path = "LDAP://CN=Schema,CN=Configuration," & GetDomain()

	Set objADOconn = Server.CreateObject("ADODB.Connection")
	Set objADOCom = Server.CreateObject("ADODB.Command")
	Set objRS = Server.CreateObject("ADODB.Recordset")
	
	objADOconn.Provider ="ADsDSOObject"
	objADOconn.Open "Active Directory Provider"
	
	set objADOCom.ActiveConnection = objADOconn
	
	strADOQueryString="<" & Path & ">;(&(ldapDisplayName=" & strLdapDisplayName & ")(objectCategory=attributeSchema));adspath,Name,cn;subtree"

	objADOCom.CommandText = strADOQueryString
	Set objRS = objADOCom.Execute
	
	' Return Object
	tempAttribAdspath = objRS.fields("adspath")
	Set FindSchemaAttribByldapDisplayName = GetObject(tempAttribAdspath)
	
	' Destroy Objects
	Set objADOconn = Nothing
	Set objADOCom = Nothing
	Set objRS = Nothing
	
End Function
'********************************************************************
'*
'* Function DetailError(detailedError)
'* Purpose: Fire a Fatal Error to the screen and stop further proccessing
'* Input:   	detailedError	Text Message to display on the Screen (String)
'*				
'* Output:  None
'*
'********************************************************************
Function DetailError(detailedError)
Dim ErrResponseString, descErr
	If Err.number <> 0 then	
		descErr = Err.description
		
		If Write_Debug Then
			Response.Write "<font color=red>General Error: "
			Response.Write "<BR>"
			Response.Write detailedError
			Response.Write "</font>"
			Response.Write "<BR>"
			Response.Write "Description: " & descErr
			Response.Write "<BR>"
			Response.Write "Number: " & Err.number 
			Response.Write "<BR><BR><BR>"
			Response.Write "<A HREF=""Default.asp"">Click Here to go back to the Main Menu.</A>"
			Response.Write "<BR>"
			Response.End 
		Else
			ErrResponseString = "Error.asp?Number=" & Err.number & "&rndnum="& rndnum & "&detailedError=" & detailedError & "&Descrip=" & descErr
			Response.Write ErrResponseString
		
			' Write this error to the Log.
			WriteLog "ERROR= " & descErr ,1,detailedError
			
			' Redirect Page.
			Response.Redirect ErrResponseString
			Response.End 
		End If
	End if
End Function

%>
