<%

'*
'* Copyright (C) 1999 Microsoft Corporation
'*



'********************************************************************
'*
'* Function doMatch(value1, value2)
'* Purpose: Return whether two string match
'* Input:   value1			- String (String)
'*			value2			- String (String)
'*						 
'* Output:  boolean - True/False
'*
'********************************************************************
Function doMatch(value1, value2)
	If trim(lcase(value1)) = trim(lcase(value2)) then
		doMatch = True
	Else
		doMatch = False
	End If
End Function

'********************************************************************
'*
'* Function doCheckedMatch(value1, value2)
'* Purpose: If 2 strings match, print Checked
'* Input:   value1			- String (String)
'*			value2			- String (String)
'*						 
'* Output:  String - If there is a match, write to screen "checked"
'*
'********************************************************************
Function doCheckedMatch(value1, value2)
	If trim(lcase(value1)) = trim(lcase(value2)) then
		Response.Write "checked"
	End If
End Function


'********************************************************************
'*
'* Function doSelectedMatch(value1, value2)
'* Purpose: If 2 strings match, print selected
'* Input:   value1			- String (String)
'*			value2			- String (String)
'*						 
'* Output:  String - If there is a match, write to screen "selected"
'*
'********************************************************************
Function doSelectedMatch(value1, value2)
	If trim(lcase(value1)) = trim(lcase(value2)) then
		Response.Write "selected"
	End If
End Function

'********************************************************************
'*
'* Function EncodeSql(strSQL)
'* Purpose: Replace symbols that are bad for SQL queries
'* Input:   strSQL			- String (String)
'*						 
'* Output:  String - String ready for SQL
'*
'********************************************************************
Function EncodeSql(strSQL)
	Dim tempSQL
	tempSQL = Replace(strSQL,"'", "''")
	EncodeSql = tempSQL
End Function

'********************************************************************
'*
'* Function GetDriveLetter(drivePath)
'* Purpose: Pass in a Path and Return the Drive Letter.  Must be valid!
'* Input:   drivePath		- File Path (String)
'*						 
'* Output:  String - Drive Letter
'*
'********************************************************************
Function GetDriveLetter(drivePath)
	Dim tempLetter
	tempLetter = Mid(drivePath,1,1)
	GetDriveLetter = tempLetter
End Function

'********************************************************************
'*
'* Function ClearDriveFromPath(drivePath)
'* Purpose: Pass in a Path and Return the Path without the drive letter
'* Input:   drivePath		- File Path (String)
'*						 
'* Output:  String - full Path.
'*
'********************************************************************
Function ClearDriveFromPath(drivePath)
	Dim tempLetter
	tempLetter = Mid(drivePath,4)
	ClearDriveFromPath = tempLetter
End Function

'********************************************************************
'*
'* Function GetServerNameFromIISPath(iisPath)
'* Purpose: Get Server Name from the IIS Path
'* Input:   iisPath		- IIS Path (String) 
'*				
'* Output:  String - Server Name
'*
'********************************************************************
Function GetServerNameFromIISPath(iisPath)
	Dim tempPath, lastWack
	' Clean out the IIS:// Protocol from the Path
	tempPath = Mid(iisPath,7,len(iisPath))
	' Find the Last Wack after the serverName
	lastWack = Instr(1,tempPath,"/")
	' Now Clean out everything after, including, the wack.
	tempPath = Mid(tempPath,1,lastWack - 1)
	'Return the server.
	GetServerNameFromIISPath =  tempPath
End Function

'********************************************************************
'*
'* Function GetServerInstanceFromIISPath(iisPath)
'* Purpose: Get Server Instance Name IIS Path
'* Input:   iisPath		- IIS Path (String) 
'*				
'* Output:  String - Server Name
'*
'********************************************************************
Function GetServerInstanceFromIISPath(iisPath)
	Dim tempPath, lastWack
	' Find the Last Wack on the End of the IISPath
	lastWack = Instrrev(iisPath,"/")
	'Clean Out Every thing before it
	tempPath = mid(iisPath,lastWack+1)
	' Return the Instance number
	GetServerInstanceFromIISPath = tempPath
End Function

'********************************************************************
'*
'* Function Sub WritePath()
'* Purpose: Write the Adspath with links to the browser
'* Input:   adminStyle			Show the Full Path	(True/False)
'*				
'* Output:  String - One line Only
'*
'********************************************************************
Sub WritePath(adminStyle)
	%>
		
		&nbsp;&nbsp;&nbsp;<%=BuildPathNav(adspath, adminStyle)%>
		<BR>
	<%
End Sub
'********************************************************************
'*
'* Function BuildPathNav(sAdsPath)
'* Purpose: Builds a Clickable path for direct access to manage a chosen OU.
'* Input:   	strAdsPathofOU			sAdsPath of Container Only (String)
'*				boolFullPath			Show the entire Path. This will override
'*											whether ASPServices are on or not
'*											(True/False)
'*				
'* Output:  String
'*
'********************************************************************
Function BuildPathNav(strAdsPathofOU,boolFullPath)
	Dim tempPath, buildTempPath, CurrentOU, NextOU, strAdsPath
	Dim tempParentOU, tempOUName, tempOUAdspath, tempDCPath
	Dim DCLoc, noMoreOUs, strSeperator
	
	' Set the string sperator.  This will be the charactor used that displays a 
	'	seperation between each ADSPath object link
	strSeperator = "/"
	
	' Clean the Protocal out of the Adspath.  Will put it back when/where needed.
	strAdsPath = Replace(ucase(strAdsPathofOU),"LDAP://","")
	
	' Set the noMoreOUs flag.  This is used to stop the looping once there are no more
	'	OU's to work with.
	noMoreOUs = False
	Do While Not noMoreOUs
	
		' Get the Placement of the current OU
		CurrentOU = Instr(1,uCase(strAdsPath),"OU=")
			'If the current OU could not be found, Get the CN.  This is in case the 
			'	the container is a builtin object.  Built in objects are not OU's but
			'	CN's.
			If CurrentOU = 0 then
				' Get the Placement of the current OU
				CurrentOU = Instr(1,uCase(strAdsPath),"CN=")
			End If
	
		' Get the Placement of the Next OU
		NextOU = Instr(CurrentOU + 3,uCase(strAdsPath),"OU=")
		
		' If there are still OU's left to loop through, do the following
		If NextOU <> 0 then
				' Get the name of the OU that will be displayed
				tempOUName = lcase(Mid(strAdsPath,CurrentOU + 3,NextOU -5))
				
				' Get the ADSPath of the OU.
				tempOUAdspath = "LDAP://" & lcase(strAdsPath)
				
				' Build the HTML A Tag that will be added to the tempPath.
				If BROWSER_TYPE = "ppc" then
					buildTempPath = buildTempPath & "<a href=""PPC-ManageOU.asp?adspath=" & tempOUAdspath & "&rndnum=" & rndnum & """ class=""Path"">"
				Else
					buildTempPath = buildTempPath & "<a href=""ManageOU.asp?adspath=" & tempOUAdspath & "&rndnum=" & rndnum & """ class=""Path"">"
				End If
				buildTempPath = buildTempPath & tempOUName
				buildTempPath = buildTempPath & "</a>"
				buildTempPath = buildTempPath & "<Font color=""black""><small>&nbsp;" & strSeperator & "&nbsp;</small></font>"
				tempPath = buildTempPath & tempPath
				
				' Clear the buildTempPath for the next use.
				buildTempPath = ""
				
				' Move the ADSPath to the next OU.
				strAdsPath = mid(strAdsPath,NextOU)
		Else
			' This section is used to process the last OU.
			
				' Check to see if ASP Services is Enabled.  If so, skip the last OU.  It should never be 
				'	used anyway.
				If Not ASP_SERVICES_ENABLED or boolFullPath Then
				
					' Get the Location of the Domain Controller
					DCLoc = Instr(1,ucase(strAdsPath),"DC=")
					
					' If the Current AdsPath is the domain itself.
					If DCLoc = 1 Then
						If BROWSER_TYPE = "ppc" then
							buildTempPath = buildTempPath & "<a href=""PPC-ManageOU.asp?adspath=LDAP://" & lcase(strAdsPath) & "&rndnum=" & rndnum & """ Class=""Path"" >"
						Else
							buildTempPath = buildTempPath & "<a href=""ManageOU.asp?adspath=LDAP://" & lcase(strAdsPath) & "&rndnum=" & rndnum & """ Class=""Path"" >"
						End If
						buildTempPath = buildTempPath & lcase(strAdsPath)
						buildTempPath = buildTempPath & "</a>"
						
						' Send back the DC Path and exit function
						BuildPathNav = buildTempPath
						Exit Function
					End If
					
					
					' Set the NextOU Variable to the location of the DC Location
					NextOU = DCLoc
					
					' Get the name of the OU that will be displayed
					tempOUName = lcase(Mid(strAdsPath,CurrentOU + 3,NextOU -5))
					
					' Get the ADSPath of the OU.
					tempOUAdspath = "LDAP://" & lcase(strAdsPath)
				
					' Build the HTML A Tag that will be added to the tempPath.
						If BROWSER_TYPE = "ppc" then
							buildTempPath = buildTempPath & "<a href=""PPC-ManageOU.asp?adspath=" & tempOUAdspath & "&rndnum=" & rndnum & """ Class=""Path"" >"
						Else
							buildTempPath = buildTempPath & "<a href=""ManageOU.asp?adspath=" & tempOUAdspath & "&rndnum=" & rndnum & """ Class=""Path"" >"
						End If
					buildTempPath = buildTempPath & tempOUName
					buildTempPath = buildTempPath & "</a>"
					buildTempPath = buildTempPath & "<Font color=""black""><small>&nbsp;" & strSeperator & "&nbsp;</small></font>"
					
					' Move AdsPath to the Domain Controller path, which is next.
					strAdsPath = mid(strAdsPath,NextOU)	
					
					If BROWSER_TYPE = "ppc" then
						tempDCPath = tempDCPath & "<a href=""PPC-ManageOU.asp?adspath=LDAP://" & strAdsPath & "&rndnum=" & rndnum & """ Class=""Path"" >"
					Else
						tempDCPath = tempDCPath & "<a href=""ManageOU.asp?adspath=LDAP://" & strAdsPath & "&rndnum=" & rndnum & """ Class=""Path"" >"
					End If
					tempDCPath = tempDCPath & lcase(strAdsPath)
					tempDCPath = tempDCPath & "</a>"
					tempDCPath = tempDCPath & "<Font color=""black""><small>&nbsp;" & strSeperator & "&nbsp;</small></font>"
					
					
					' Add the new OU HTML info to the Beginning of the tempPath.  This is because the AdsPath is 
					'	read from right to left.  Domain information is on the right and nesting OU's flow to the left.
					tempPath = tempDCPath & buildTempPath & tempPath
					
					' Just in case, clear the buildTempPath for the next use.
					buildTempPath = ""
					
				End If
			noMoreOUs = True
		End If
	Loop
	' If there was no tempPath built, no need to clean the end of it.
	If Len(tempPath) <> 0 then
		' Clean Out the End of the tempPath
		tempPath = mid(tempPath,1,len(tempPath)-30)
	End If
	' Pass the newly built path back.
	BuildPathNav = tempPath
End Function

'********************************************************************
'*
'* Function WriteArrayWithBR(ArrayItem)
'* Purpose: Pass in an item that might be a string or an array.
'* Input:   	g_UserGroupObj		User's Object (ADS Object)
'*				
'* Output:  String
'*
'********************************************************************
Function WriteArrayWithBR(ArrayItem)
On Error Resume Next
	Dim arrayValue, tempOUT
	
	If typename(ArrayItem) <> "Empty" then
		If typename(ArrayItem) = "String" or not IsArray(ArrayItem) then
				'Return String
				WriteArrayWithBR = ArrayItem
		Else
			For Each arrayValue in ArrayItem
				If tempOUT = "" then 
					tempOUT = arrayValue & "<BR>" & Chr(10) 
				Else
					tempOUT = tempOUT & arrayValue & "<BR>"  & Chr(10)
				End If
			Next
			
			'Return String
			WriteArrayWithBR = tempOUT
		End If
	End If
DetailError "General Error (WriteArrayWithBR)"
End Function

'********************************************************************
'*
'* Function WriteArray(ArrayItem)
'* Purpose: Pass in an item that might be a string or an array.
'* Input:   	g_UserGroupObj		User's Object (ADS Object)
'*				
'* Output:  String
'*
'********************************************************************
Function WriteArray(ArrayItem)
On Error Resume Next
	Dim arrayValue, tempOUT
	
	If typename(ArrayItem) <> "Empty" then
		If typename(ArrayItem) = "String" or not IsArray(ArrayItem) then
				'Return String
				WriteArray = ArrayItem
		Else
			For Each arrayValue in ArrayItem
				If tempOUT = "" then 
					tempOUT = arrayValue & Chr(10)
				Else
					tempOUT = tempOUT & arrayValue & Chr(10)
				End If
			Next
			
			'Return String
			WriteArray = tempOUT
		End If
	End If
DetailError "General Error (WriteArray)"
End Function

'********************************************************************
'*
'* Function AddSearchArray(varItem, varValue)
'* Purpose: Use this Function to add Its to the SearchArrayItems Pulic Array
'* Input:   	varItem		Name of Attribute (String)
'*				varValue	Value to Search For (String)
'*
'* Output:		None
'*
'********************************************************************
Function AddSearchArray(varItem, varValue)
	If varValue <> "" then
		SearchArrayItems(ArrayCounter) = varItem & "=" & varValue
		ArrayCounter = ArrayCounter + 1
	End If
End Function

'********************************************************************
'*
'* Function AddResultArray(varItem)
'* Purpose: Add Item to Results Array
'*
'* Input:   	varItem		Items Value (String)
'*
'* Output:		None
'*
'********************************************************************
Function AddResultArray(varItem)
	If varItem <> "" then
		ResultArrayItems(ResultArrayCounter) = varItem
		ResultArrayCounter = ResultArrayCounter + 1
	End If
End Function

'********************************************************************
'*
'* Function CheckSearchArray(varValue)
'* Purpose: Check to see if an Item has a value.  And if it does
'*				Make the Array for the Results grow by 1
'*
'* Input:   	varValue		Item to Check for (String)
'*
'* Output:		None
'*
'********************************************************************
Function CheckSearchArray(varValue)
	If varValue <> "" then
		Redim SearchArrayItems(ArrayCounter)
		ArrayCounter = ArrayCounter + 1
	End If
End Function

'********************************************************************
'*
'* Function ReadyForScript(strValue)
'* Purpose: Clean string for use in a script.
'* Input:   	strValue			Item to Check for (Array/String)
'*
'* Output:		String - Cleaned version of the original string
'*
'********************************************************************
Function ReadyForScript(strValue)
	ReadyForScript = Replace(strValue,"'","''")
End Function

'********************************************************************
'*
'* Function ParentOU(AdsPath)
'* Purpose: Get the Parent OU AdsPath of a Given Object
'* Input:   	AdsPath				Ads Path of Object (String) 
'*
'* Example : Input		= Ldap://OU=ChildOU,OU=TestOU,DC=MyASPCompany,DC=Com
'* Example : Output		= Ldap://OU=TestOU,DC=MyASPCompany,DC=Com
'*
'* Output:		String - Output of Parent Organizational Unit
'*
'********************************************************************
Function ParentOU(AdsPath)
	Dim CurrentOU, NextOU, tempParentOU
	CurrentOU = Instr(1,uCase(AdsPath),"OU=")
	'Response.Write "AdsPath [1]:" & AdsPath & "<BR>"
	'Response.Write "CurrentOU [1]:" & CurrentOU & "<BR>"
		'If there is no current OU, then try using CN for a builtIn Object
		If CurrentOU = 0 then
			CurrentOU = Instr(1,uCase(AdsPath),"CN=")
			'Response.Write "CurrentOU [2]:" & CurrentOU & "<BR>"
		End If
	NextOU = Instr(CurrentOU + 3,uCase(AdsPath),"OU=")
		'Response.Write "NextOU [1]:" & NextOU & "<BR>"
		' If ther is no Next OU, then try a Domain controller.
		If NextOU = 0 then
			NextOU = Instr(1,uCase(AdsPath),"DC=")
			'Response.Write "NextOU [2]:" & NextOU & "<BR>"
		End If
	If NextOU <> 0 then
		' Check to see if ASP Services is Enabled
		If ASP_SERVICES_ENABLED Then
			tempParentOU = ucase(Mid(AdsPath,NextOU,14))
			'Response.Write "tempParentOU [1]:" & tempParentOU & "<BR>"
			' If the Parent OU is the Hosting OU, then keep the current ADSPath
			If tempParentOU = "OU=" & ucase(HOSTING_OU) & ",DC=" and not ADMIN_FLAG then
				'Response.Write "tempParentOU [2]:" & "OU=" & ucase(HOSTING_OU) & ",DC=" & "<BR>"
				ParentOU = AdsPath
				Exit Function
			Else
			' If the ADMIN_FLAG Global Variable is set to true, then even though 
			'	the Web Admin is in ASP Mode, we will continue to walk the tree.
			tempParentOU = Mid(adsPath,NextOU)
			ParentOU= "LDAP://" & tempParentOU
				'Response.Write "tempParentOU [1]:" & tempParentOU & "<BR>"
				'Response.Write "ParentOU [1]:" & ParentOU & "<BR>"
			End If
		End If
		
		' Send back the Parent OU.
		tempParentOU = Mid(adsPath,NextOU)
		ParentOU= "LDAP://" & tempParentOU
			'Response.Write "tempParentOU [2]:" & tempParentOU & "<BR>"
			'Response.Write "ParentOU [2]:" & ParentOU & "<BR>"
		
	Else
		' If there is no parent OU, then Leave ADSPath AS Is
		ParentOU= AdsPath
			'Response.Write "ParentOU [3]:" & ParentOU & "<BR>"
	End If
End Function

'********************************************************************
'*
'* Function CleanOutAdsPathEnds(sAdsPath)
'* Purpose: Cleans out the Protocol and Domain Info from the AdsPath
'* Input:   	sAdsPath		Ads Path of Object(String)
'*
'* Example : Input		= Ldap://OU=TestOU,DC=MyASPCompany,DC=Com
'* Example : Output		= OU=TestOU
'*
'* Output:		String - Cleaned out version of object
'*
'********************************************************************
Function CleanOutAdsPathEnds(sAdsPath)
	Dim topDomainLoc, OtherSideOfOULoc, TotalLength
	TotalLength = Len(sAdsPath)
	
	' Check to see if ASP Services is Enabled
	If ASP_SERVICES_ENABLED Then
		topDomainLoc = Instr(1,uCase(sAdsPath),"OU=" & ucase(HOSTING_OU) & ",DC=")
	Else
		topDomainLoc = Instr(1,uCase(sAdsPath),"DC=")
	End If
	'Response.Write topDomainLoc
	'Response.End 
		
		If topDomainLoc =< 8  then
			CleanOutAdsPathEnds = replace(lcase(sAdsPath),"ldap://","")
		Else
			CleanOutAdsPathEnds = Mid(sAdsPath,8,topDomainLoc - 9)
		End If
End Function

'********************************************************************
'*
'* Function CleanOutDomainEnds(sAdsPath)
'* Purpose: Cleans out the Domain Info from the AdsPath
'* Input:   	sAdsPath		Ads Path of Object(String)
'*
'* Example : Input		= OU=TestOU,DC=MyASPCompany,DC=Com
'* Example : Output		= OU=TestOU
'*
'* Output:		String - Cleaned out version of object
'*
'********************************************************************
Function CleanOutDomainEnds(sAdsPath)
	Dim topDomainLoc, OtherSideOfOULoc, TotalLength
	TotalLength = Len(sAdsPath)
	topDomainLoc = Instr(1,uCase(sAdsPath),"DC=")
	CleanOutDomainEnds = Mid(sAdsPath,1,topDomainLoc -2)
End Function

'********************************************************************
'*
'* Function CleanOutOUPrefix(strItem)
'* Purpose: Cleans out the OU Prefix from the AdsPath
'* Input:   	strItem		Ads Path of an Object (String)
'*
'* Example : Input		= OU=ChildOU,OU=TestOU
'* Example : Output		= ChildOU,TestOU
'*
'* Output:		String - Cleaned out version of string
'*
'********************************************************************
Function CleanOutOUPrefix(strItem)
	CleanOutOUPrefix = Replace(lcase(strItem), "ou=","")
	CleanOutOUPrefix = Replace(lcase(CleanOutOUPrefix), "cn=","")
	CleanOutOUPrefix = Replace(lcase(CleanOutOUPrefix), "dc=","")
End Function
'********************************************************************
'*
'* Function GetRootOU(sAdsPath)
'* Purpose: Get/Return the Root OU of a Given Object
'* Input:   	sAdsPath			Ads Path of Object (String)
'*
'* Example : Input		= Ldap://OU=Child2,OU=Child1,OU=TestOU,DC=MyASPCompany,DC=Com
'* Example : Output		= TestOU
'*
'* Output:		String - Root Organizational Unit
'*
'********************************************************************
Function GetRootOU(sAdsPath)
	Dim topDomainLoc, OtherSideOfOULoc, TotalLength, HostingOULoc, HostingVarLen
	TotalLength = Len(sAdsPath)
	topDomainLoc = Instr(1,uCase(sAdsPath),"DC=")
		' Check to see if ASP Services is Enabled
		If ASP_SERVICES_ENABLED Then
			HostingVarLen = Len("OU=" & ucase(HOSTING_OU))
			HostingOULoc = Instr(1, uCase(sAdsPath), "OU=" & ucase(HOSTING_OU))
			If HostingOULoc = 0 then
				HostingOULoc = Instr(1, uCase(sAdsPath), "CN=")
					If HostingOULoc = 0 then
						GetRootOU = sAdsPath
					Else
						OtherSideOfOULoc = InstrRev(uCase(sAdsPath),"DC=",HostingOULoc)
						GetRootOU = Mid(sAdsPath,topDomainLoc)
					End If
			Else
				OtherSideOfOULoc = InstrRev(uCase(sAdsPath),"OU=",HostingOULoc)
				GetRootOU = Mid(sAdsPath,OtherSideOfOULoc + 3,topDomainLoc - OtherSideOfOULoc - HostingVarLen - 5)
			End If
		Else
			OtherSideOfOULoc = InstrRev(uCase(sAdsPath),"OU=")
			GetRootOU = Mid(sAdsPath,OtherSideOfOULoc + 3,topDomainLoc - OtherSideOfOULoc - 4)	
		End If
End Function

'********************************************************************
'*
'* Function GetRootOUAdsPath(sAdsPath)
'* Purpose: Get/Return the Ads Path of Root OU for a Given Object
'* Input:   	sAdsPath			Ads Path of Object (String)
'*
'* Example : Input		= Ldap://OU=Child2,OU=Child1,OU=TestOU,DC=MyASPCompany,DC=Com
'* Example : Output		= Ldap://OU=TestOU,DC=MyASPCompany,DC=Com
'*
'* Output:		String - Root Organizational Unit Ads Path
'*
'********************************************************************
Function GetRootOUAdsPath(sAdsPath)
	Dim topDomainLoc, OtherSideOfOULoc, TotalLength, HostingOULoc
	TotalLength = Len(sAdsPath)
	topDomainLoc = Instr(1,uCase(sAdsPath),"DC=")
		' Check to see if ASP Services is Enabled
		If ASP_SERVICES_ENABLED Then
			' Look for the Hosting OU from the left of the AdsPath.
			HostingOULoc = Instr(1, uCase(sAdsPath), "OU=" & ucase(HOSTING_OU))
			If HostingOULoc <> 0 then
				OtherSideOfOULoc = InstrRev(uCase(sAdsPath),"OU=",HostingOULoc)
					' If this is the last container than.
					If OtherSideOfOULoc = 0 then
						GetRootOUAdsPath = sAdsPath
					Else
						GetRootOUAdsPath = "LDAP://" & Mid(sAdsPath,OtherSideOfOULoc)
					End If
			Else
				' If there is no Hosting OU Present, Go For the Last OU.
				OtherSideOfOULoc = InstrRev(uCase(sAdsPath),"OU=")
					' If there is no OU in the AdsPath, the try CN=Users
					If OtherSideOfOULoc = 0 then
						OtherSideOfOULoc = InstrRev(lCase(sAdsPath),"cn=users")
						' If this users in not in a container, return the full ADSPath
						GetRootOUAdsPath = sAdsPath
					Else
						GetRootOUAdsPath = "LDAP://" & Mid(sAdsPath,OtherSideOfOULoc)
					End If
			End If
		Else
			'OtherSideOfOULoc = InstrRev(uCase(sAdsPath),"OU=")
			'GetRootOUAdsPath = "LDAP://" & Mid(sAdsPath,OtherSideOfOULoc)
			GetRootOUAdsPath = sAdsPath
		End If
End Function

'********************************************************************
'*
'* Function ParseOU(g_OU)
'* Purpose: Get/Return the UPN Suffix for a User
'* Input:   	g_OU		User Principal Name (String)
'*
'* Output:		String - User Principal Name Suffix
'*
'********************************************************************
Function ParseOU(g_OU)
Dim AtSignLoc
	AtSignLoc = Instr(1,g_Ou,"@")
	If AtSignLoc <> 0 then
		ParseOU = mid(g_OU,atSignLoc + 1)
	Else
		ParseOU = "Users"
	End If
End Function

'********************************************************************
'*
'* Function ParseUsernameFromADSPath(sAdsPath)
'* Purpose: Get/Return the UPN name from the AdsPath
'* Input:   	g_OU		User Ads Path(String)
'*
'* Output:		String - user UPN
'*
'********************************************************************
Function ParseUsernameFromADSPath(sAdsPath)
	Dim OULoc
	OULoc = Instr(1,Ucase(sAdsPath),"OU=")
	' if there was no OU found, then look for some of the other
	'	builtin containers
	If OULoc = 0 then
		OULoc = Instr(1,Ucase(sAdsPath),"CN=USERS")
	End If
	If OULoc = 0 then
		OULoc = Instr(1,Ucase(sAdsPath),"CN=COMPUTERS")
	End If
	If OULoc = 0 then
		OULoc = Instr(1,Ucase(sAdsPath),"CN=BUILTIN")
	End If
	ParseUsernameFromADSPath = Mid(sAdsPath,11,OULoc - 12)
End Function

'********************************************************************
'*
'* Function ParseUsername(g_UPN)
'* Purpose: Get/Return the User name from the UPN
'* Input:   	g_UPN		User UPN (String)
'*
'* Output:		String - Username (without the UPN)
'*
'********************************************************************
Function ParseUsername(g_UPN)
	Dim AtSignLoc
	AtSignLoc = Instr(1,g_UPN,"@")
	If AtSignLoc <> 0 then
		ParseUsername = mid(g_UPN,1,atSignLoc -1)
	Else
		' Assume the UPN passed does not have an At Sign.
		ParseUsername = g_UPN
	End If
End Function

'********************************************************************
'*
'* Function CleanOutProtocol(sAdsPath)
'* Purpose: Take the Protocal out of the Ads Path
'* Input:   	sAdsPath			ADSPath of an object. (String)
'*
'* Output:		True/False
'*
'********************************************************************
Function CleanOutProtocol(sAdsPath)
	dim tempDn
	tempDN = Mid(sAdsPath,8)
	CleanOutProtocol = tempDN
End Function

'********************************************************************
'*
'* Function CleanUserOutOfOU(g_OU)
'* Purpose: Clean out the user portion from an AdsPath
'* Input:   	g_OU		Ads Path of User (String)
'*
'* Output:		String - AdsPath of users Container
'*
'********************************************************************
Function CleanUserOutOfOU(g_OU)
	Dim FirstOULoc, TotalLength, tempCleanString
	TotalLength = len(g_OU)
	FirstOULoc = instr(1,lcase(g_OU),"ou=")
		' If there is no OU found, look for CN=Users
		If FirstOULoc = 0 then
			FirstOULoc = instr(1,lcase(g_OU),"cn=users")
		End If
	tempCleanString = mid(g_OU,FirstOULoc)
	CleanUserOutOfOU = "LDAP://" & tempCleanString
End Function

'********************************************************************
'*
'* Function GetGroupOutOfDN(g_OU)
'* Purpose: Get/Return Group Name from AdsPath
'* Input:   	g_OU		AdsPath of Group (String)
'*
'* Output:		String - Group CN
'*
'********************************************************************
Function GetGroupOutOfDN(g_OU)
	Dim FirstOULoc, TotalLength, tempCleanString
	If trim(g_OU) <> "" then 
		TotalLength = len(g_OU)
		FirstOULoc = instr(1,lcase(g_OU),"@")
		If FirstOULoc > 0 then
			tempCleanString = mid(g_OU,4,FirstOULoc-4)
			GetGroupOutOfDN = tempCleanString
		Else
			GetGroupOutOfDN = CleanOutDomainEnds(g_OU)
		End If
	End If
End Function

'********************************************************************
'*
'* Function GetUserOutOfAdspath(g_OU)
'* Purpose: Get/Return user from AdsPath
'* Input:   	g_OU		AdsPath of User Object (String)
'*
'* Output:		String - Username
'*
'********************************************************************
Function GetUserOutOfAdspath(g_OU)
	Dim FirstOULoc, TotalLength, tempCleanString
	If trim(g_OU) <> "" then 
		TotalLength = len(g_OU)
		FirstOULoc = instr(1,lcase(g_OU),"ou=")
		tempCleanString = mid(g_OU,4,FirstOULoc-5)
		GetUserOutOfAdspath = tempCleanString
	End If
End Function

'********************************************************************
'*
'* Function DoSpace(spaceCount)
'* Purpose: Add 2 20 pixel Gif blanks into the web page.
'* Input:   	spaceCount		Number of spaces (int)
'*
'* Output:		None - Write two 20 Pixel Gif to the screen
'*
'********************************************************************
Function DoSpace(spaceCount)
dim x
	For x = 1 to spaceCount
			Response.Write "<IMG SRC=""images/20pxSpace.gif"" width=20 Height=20>"
			'Response.Write "<IMG SRC=""images/20pxSpace.gif"" width=20 Height=20>"
	Next
End Function

'********************************************************************
'*
'* Function IsInArray(arrayItem,Lookfor)
'* Purpose: Checks to see if an item is in an array
'* Input:   	arrayItem		The array Item (Array)
'*				LookFor			Item you are looking for (String)
'*
'* Output:		True/False
'*
'********************************************************************
Function IsInArray(arrayItem,Lookfor)
Dim items
	IsInArray = False
	For each items in arrayItem
		If lcase(items) = lcase(Lookfor) then IsInArray = True
	Next
End Function

'********************************************************************
'*
'* Function IsOnExclusionList(Item)
'* Purpose: Checks to see if a group is a member on the exclusion list.
'* Input:   	Item		Group Name (String)
'*
'* Output:		True/False
'*
'********************************************************************
Function IsOnExclusionList(Item)
Dim CheckGroupName, CheckGroupItemCut
	' Assume that the Item is not on the exclusion list
	IsOnExclusionList = False
	
	'Response.Write "Checking For: " & Item & "<BR>"
	'Response.Write "@ Postion: " & instr(1,Item,"@") & "<BR>"
	
	If instr(1,Item,"@") <> 0 then
		CheckGroupItemCut = Mid(Item,1,instr(1,Item,"@"))
		For Each CheckGroupName in GROUP_EXCLUSION_LIST
			If lcase(CheckGroupItemCut) = lcase(CheckGroupName) then
				IsOnExclusionList = True
			End If
				'Response.Write "Exclueded: " & CheckGroupName & "<BR>"
		Next
	End If
End Function

'********************************************************************
'*
'* Function DomainDN2DomainDNS(domDN)
'* Purpose: Returns the DN for a domain sting which is in DNS format
'*
'* Input:   domDN				Domain Controller String in DN fashion
'*						
'* Output:  string
'*
'*					Example Input	: DC=WestCoast,DC=MSN,DC=Com
'*					Example Output	: DomainDNS2DomainDN(WestCoast.MSN.Com)
'********************************************************************
Function DomainDN2DomainDNS(domDN)
	' Dim Variables
	Dim tmpResults
	' 
	tmpResults = Replace(domDN,",DC=", ".")
	
	' Return the Domains DN
	DomainDN2DomainDNS = tmpResults
	
End Function

'********************************************************************
'*
'* Function DomainDNS2DomainDN(domDNS)
'* Purpose: Returns the DN for a domain sting which is in DNS format
'*
'* Input:   domDNS				Domain Controller String in DNS fashion
'*						
'* Output:  string
'*
'*					Example Input	: DomainDNS2DomainDN(WestCoast.MSN.Com)
'*					Example Output	: DC=WestCoast,DC=MSN,DC=Com	
'********************************************************************
Function DomainDNS2DomainDN(domDNS)
	' Dim Variables
	Dim tmpResults
	' 
	tmpResults = "DC=" & Replace(domDNS,".",",DC=")
	
	' Return the Domains DN
	DomainDNS2DomainDN = tmpResults
	
End Function



%>