<%

'********************************************************************
'*				---   Web Admin - DNS Service   ---
'*
'* Created By: conrada and Ed tremblay 
'*
'* Svc-WebServer.asp 
'* 
'* Notes:   	
'*			- Any Items marked optional with [braces] need to have a 
'*				blank string passed into the function.
'*
'*			- Main.asp and Utils.asp libraries need to be called from 
'*				the calling ASP Page for this library.
'*
'* For this routine to run correctly the WMI DNS provider must be loaded on the server 
'* that these web pages will run on.
'* 
'* For this routine to work properly the DNS service need to be runnin on a Windows 2000
'* DNS Server.  
'*  
'* Location of the DNS provider - ftp.microsoft.com/reskit/win2000/dnsprov.zip
'*
'* To install the dns provider,
'* 1. Copy dnsschema.mof and dnsprov.dll to <winntdir>\system32\wbem.
'* 2. Run "mofcomp dnsschema.mof" to register the class information.
'* 3. Run "regsvr32 dnsprov.dll" to register the dll.



'********************************************************************
'*
'* Sub DnsZoneCreate()
'*
'* Purpose: Creates a Zone.
'*
'* Input:   sDNSServer           a machine name
'*         
'*          sDNSZoneType			type of zone to create (Primary, ADIntegrated, etc.
'*          sDNSZoneName			name of DNS zone ("foobar.com")
'*          strPropertyArray     The job to perform
'*
'* Output:  Results are either printed on screen or saved in strOutputFile.
'*
'********************************************************************

Function DnsZoneCreate(sDNSServerName, _
                      sDNSZoneType, _
                      sDNSZoneName)

    On Error resume next

    Dim objFileSystem, objOutputFile, objService, objDnsSet, objServer, objInst
    Dim sUserName, sPassword
    Dim strPropertyArray()
    ReDim strPropertyArray(20)


    'Establish a connection with the server. exit function on error
    ' true indicates error in binding to wmi and the dns provider
    If blnConnect("root\microsoftdns", _
                   sUserName, _
                   sPassword, _
                   sDNSServerName, _
                   objService) Then
        Exit Function
    End If

    Set objServer = objService.Get("MicrosoftDNS_Server.name="".""")
      If Err.Number Then
        Response.Write ("Error 0x" & CStr(Hex(Err.Number)) & _
                    " occurred in connecting to the DNS server")
        If Err.Description <> "" Then
           call Response.Write ("Error description: " & Err.Description & ".")
        End If
        Exit Function
    End If	
    
    
    Set objDnsSet = objService.Get("MicrosoftDNS_ZONE")
     If Err.Number Then
        Response.Write ("Error 2x" & CStr(Hex(Err.Number)) & _
                    " occurred in connecting to the DNS server.")
        If Err.Description <> "" Then
           call Response.Write ("Error description: " & Err.Description & ".")
        End If
        Exit Function
    End If	
    
    '//strPropertyArray(0) = "0" '//dsintegrated zone
    '//strPropertyArray(0) = "1" '//Primary zone
    '//strPropertyArray(0) = "2" '//Secondary zone
    '//strPropertyArray(2) = name of primary zone
    '//
    '//example - "myzone.com" for primary or "0.0.10.in-addr.arpa" for a
    '//           reverse zone for ip address 10.0.0.2
    

    strPropertyArray(0) = sDNSZoneType
    strPropertyArray(2) = sDNSZoneName
    objInst = objDnsSet.CreateZone(strPropertyArray(2), strPropertyArray(0))
    
    If Err.Number <> 0 Then
        WriteLog "DNSZoneCreate: " & sUsername, "Error", "Creating:" & sDNSZoneName
    Else    
		WriteLog "DNSZoneCreate: " & sUsername, "Success", "Creating:" & sDNSZoneName
    End If
    
    
    set objServer	= nothing
    set objService	= nothing
    set objDnsSet	= nothing
    set objService	= nothing
    set objInst		= nothing


End Function

'********************************************************************
'*
'* Sub DnsRecordCreate()
'*
'* Purpose: Creates DNS records (A, MX Cname, etc.).
'*
'* Input:   strServer           a machine name
'*          strOutputFile       an output file name
'*          strUserName         the current user's name
'*          strPassword         the current user's password
'*          Cresource             The job to perform
'*
'* Output:  Results are either printed on screen or saved in strOutputFile.
'*
'********************************************************************
Function DnsRecordCreate(sDNSParentName, _
                        sDNSIPAddr, _
                        sDNSservername, _
                        sDNSMailservername, _
                        sDNSMXPriority, _
                        sDNSRecordType)


    On Error Resume Next
    
    Dim objFileSystem, objDns, objService, objServer
    Dim objMethod, objInParam, objOutParam
    Dim sRecordCreate
    Dim sUserName
    Dim sPassword
    Dim sServer
    
    Const MX_DNS_RECORD_TYPE = "MX"
    Const A_DNS_RECORD_TYPE = "A"
 
    
     'Establish a connection with the server.
    If blnConnect("root\microsoftdns", _
                   sUserName, _
                   sPassword, _
                   sDNSservername, _
                   objService) Then

        Exit Function
    End If

  
    Set objDns = objService.Get("MicrosoftDNS_ResourceRecord")
    Set objServer = objService.Get("MicrosoftDNS_Server.Name="".""")
    Set objMethod = objDns.Methods_("CreateInstanceFromTextRepresentation")
    Set objInParam = objMethod.inParameters.SpawnInstance_()
        
    '// DnsRecord.vbs /Add MX mailtest.Com @ zMail 10 /s asp-ad-02

    '//objInParam.TextRepresentation = "xz99.asphosting.com IN A 10.10.10.98"
    
    
    Select Case sDNSRecordType
                Case MX_DNS_RECORD_TYPE
                    sRecordCreate = sDNSParentName
                    sRecordCreate = sRecordCreate & " IN "
                    sRecordCreate = sRecordCreate & sDNSRecordType & " "
                    sRecordCreate = sRecordCreate & sDNSMXPriority & " "
                    sRecordCreate = sRecordCreate & sDNSMailservername
                    sRecordCreate = sRecordCreate & "." & sDNSParentName
                    objInParam.TextRepresentation = sRecordCreate
                    
                    '//cool1.Com IN MX  10 zMail.mailtest.Com
                    '//objInParam.TextRepresentation = "mailtest.Com IN MX 10 MailSvr"
                Case A_DNS_RECORD_TYPE
                     sRecordCreate = sDNSMailservername & "."
                     sRecordCreate = sRecordCreate & sDNSParentName
                     sRecordCreate = sRecordCreate & " IN "
                     sRecordCreate = sRecordCreate & sDNSRecordType & " "
                     sRecordCreate = sRecordCreate & sDNSIPAddr
                     objInParam.TextRepresentation = sRecordCreate
                    '//objInParam.TextRepresentation = "axz92.cool1.com IN A 10.10.10.98"
                Case Else
                    '/ set error message
                    Exit Function
    End Select
    
    objInParam.DnsServerName = objServer.Name
    objInParam.ContainerName = sDNSParentName
        
    
    Set objOutParam = objDns.ExecMethod_("CreateInstanceFromTextRepresentation", objInParam)
	If Err.Number <> 0 Then
        
        WriteLog "DNSRecordCreate: " & sUsername, "Error", "Creating:" & sDNSMailservername
    Else    
		WriteLog "DNSRecordCreate: " & sUsername, "Success", "Creating:" & sDNSMailservername
    End If
    
    set objServer	 = nothing
    set objService	 = nothing
    set objDns		 = nothing
    set objMethod	 = nothing
    set objInParam   = nothing

    
End Function

'********************************************************************
'*
'* Function blnConnect()
'*
'* Purpose: Connects to machine sDNSserver.
'*
'* Input:   sDNSserver       a machine name
'*          strNameSpace    a namespace
'*          sUserName     name of the current user
'*          sPassword     password of the current user
'*
'* Output:  objService is returned  as a service object.
'*          sDNSserver is set to local host if left unspecified
'*
'********************************************************************
Function blnConnect(ByVal strNameSpace, _
                            ByVal sUserName, _
                            ByVal sPassword, _
                            ByRef sDNSserver, _
                            ByRef objService)

    On Error Resume Next

    Dim objLocator, objWshNet

    blnConnect = False     'There is no error.

    'Create Locator object to connect to remote CIM object manager
    Set objLocator = CreateObject("WbemScripting.SWbemLocator")
    If Err.Number Then
        Response.Write ("Error 0x" & CStr(Hex(Err.Number)) & _
                    " occurred in creating a locator object.")
        If Err.Description <> "" Then
           call Response.Write ("Error description: " & Err.Description & ".")
        End If
        blnConnect = True     'An error occurred
        Exit Function
    End If

    'Connect to the namespace which is either local or remote
    Set objService = objLocator.ConnectServer(sDNSserver, strNameSpace, _
       sUserName, sPassword)
    objService.Security_.impersonationlevel = 3
    If Err.Number Then
        Response.Write("Error 0x" & CStr(Hex(Err.Number)) & _
                       " occurred in connecting to server " _
                       & sDNSserver & ".")
        If Err.Description <> "" Then
            Response.Write ("Error description: " & Err.Description & ".")
        End If
        blnConnect = True     'An error occurred
    End If

    
End Function




%>