<%
'********************************************************************
'*				---   Web Admin - ManagedPC 2000 Service   ---
'*
'* Created By: Conrad Agramont & Ed Tremblay
'*
'* Svc-ManagedPC.asp
'* 
'* Notes:   	
'*			- Any Items marked optional with [braces] need to have a 
'*				blank string passed into the function.
'*
'* 
'*
'********************************************************************


'* Set Public Constants -- Org ManagedPC Service Groups
CONST MPC_PC_SERVICE_GROUP			= "ManagedPc@"
CONST MPC_SRV_SERVICE_GROUP			= "ManagedServer@"


'********************************************************************
'*
'* Function NewOrgProvisionzMPC(sOuObj)
'* Purpose: Provision ManagedPC Service for an Organization.
'* Input:   	sOuObj			Organization Unit Object (Object)
'*				 
'* Output:  None
'*
'********************************************************************
Function NewOrgProvisionMPC(sOuObj)
On Error Resume Next
	Dim NewGroupAdsPath
	
	NewGroupAdsPath = CreateGroup(sOuObj, MPC_PC_SERVICE_GROUP & GetRootOU(sOuObj.AdsPath) , "Managed PC Client Account Group", "")
	NewGroupAdsPath = CreateGroup(sOuObj, MPC_SRV_SERVICE_GROUP & GetRootOU(sOuObj.AdsPath) , "Managed Edge Server Account Group", "")

End Function

'********************************************************************
'*
'* Function DisableOrgMPC(sOuObj)
'* Purpose: Disable Managed PC Services for an Organization.
'* Input:   	sOuObj			Organization Unit Object (Object)
'*				 
'* Output:  None
'*
'********************************************************************
Function DisableOrgMPC(sOuObj)
	Dim rootDSE
	
	' Get the Root DSE Info for the domain.
	Set rootDSE = GetObject("LDAP://RootDSE")
	
	DeleteObject "LDAP://CN=" & MPC_PC_SERVICE_GROUP & GetRootOU(sOuObj.AdsPath) & ",OU=" & GetRootOU(sOuObj.AdsPath) & ",OU=" & HOSTING_OU & "," & GetDomain, "group"
	DetailError "Unable to Enable the Office 2000 Service.  Access Denied. (Svc-Office\svc-Office::DisableOrgOffice)"
	
	DeleteObject "LDAP://CN=" & MPC_SRV_SERVICE_GROUP & GetRootOU(sOuObj.AdsPath) & ",OU=" & GetRootOU(sOuObj.AdsPath) & ",OU=" & HOSTING_OU & "," & GetDomain, "group"
	DetailError "Unable to Enable the Office 2000 Service.  Access Denied. (Svc-Office\svc-Office::DisableOrgOffice)"
	
	Set RootDSE = Nothing
End Function


%>